import unittest

import numpy as np

import pywindow as pw

case_1 = {
    "elements": np.array(
        [
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
        ],
    ),
    "coordinates": np.array(
        [
            [1.881, 2.824, 1.003],
            [-0.103, 3.524, -0.259],
            [-0.287, 2.837, 2.098],
            [0.587, 3.176, -1.46],
            [-2.033, 1.238, 2.633],
            [-2.498, -2.485, 0.126],
            [3.062, -0.633, -1.623],
            [-1.603, 2.468, 1.981],
            [0.371, -2.588, 2.365],
            [0.143, -3.525, 0.233],
            [2.234, -2.64, -0.677],
            [-2.197, -1.502, 2.281],
            [1.243, 0.965, -3.152],
            [-0.29, -0.849, -3.412],
            [3.293, -1.01, 0.785],
            [-0.059, 1.562, -3.169],
            [1.925, 2.031, 2.177],
            [-1.849, -2.666, 1.406],
            [-1.94, -2.029, -2.151],
            [1.692, -2.6, 1.655],
            [-0.378, 2.563, -2.405],
            [3.106, 0.684, -1.515],
            [-0.555, -3.145, 1.482],
            [-3.071, 0.624, 1.642],
            [-2.129, 0.35, -2.798],
            [1.855, 2.646, -1.426],
            [0.439, 3.389, 0.886],
            [-3.159, 1.522, 0.495],
            [3.313, 1.246, -0.171],
            [-3.1, -0.704, 1.543],
            [2.211, 1.514, -2.299],
            [-1.208, 0.463, 3.292],
            [1.591, -2.48, -1.963],
            [-0.653, -2.021, -2.822],
            [-0.983, 0.328, -3.379],
            [2.133, -0.337, 2.783],
            [-3.377, -0.433, -0.948],
            [2.535, -1.579, 1.88],
            [-1.691, 2.618, -1.689],
            [0.252, 0.857, 3.428],
            [0.976, -0.34, 3.373],
            [3.386, 0.43, 0.933],
            [1.173, -0.448, -3.282],
            [1.557, -3.158, 0.394],
            [0.058, -1.573, 3.16],
            [-1.852, -2.857, -1.005],
            [-1.263, -0.99, 3.155],
            [-2.249, 2.658, 0.705],
            [2.543, 2.46, -0.1],
            [0.247, -2.848, -2.09],
            [-0.425, -3.4, -0.895],
            [-2.529, 1.623, -1.876],
            [1.995, -1.233, -2.614],
            [2.675, 0.833, 2.165],
            [-1.538, 3.177, -0.4],
            [0.639, 2.023, 2.843],
            [-3.281, -1.279, 0.147],
            [3.142, -1.507, -0.494],
            [-3.276, 1.042, -0.816],
            [-2.682, -0.816, -2.157],
        ],
    ),
}

case_2 = {
    "elements": np.array(
        [
            "O",
            "O",
            "O",
            "O",
            "N",
            "N",
            "N",
            "N",
            "N",
            "N",
            "N",
            "N",
            "N",
            "N",
            "N",
            "N",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "O",
            "O",
            "O",
            "O",
            "N",
            "N",
            "N",
            "N",
            "N",
            "N",
            "N",
            "N",
            "N",
            "N",
            "N",
            "N",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "O",
            "O",
            "O",
            "O",
            "C",
            "C",
            "C",
            "C",
        ],
    ),
    "coordinates": np.array(
        [
            [6.485, 1.614, 9.265],
            [6.503, 4.022, 7.044],
            [6.589, 5.724, 13.798],
            [6.495, 8.271, 11.565],
            [8.677, 2.696, 14.019],
            [8.693, 1.051, 12.256],
            [6.52, 1.871, 11.562],
            [6.454, 3.469, 13.42],
            [5.305, 4.83, 12.119],
            [5.156, 3.144, 10.364],
            [5.242, 4.963, 8.756],
            [5.187, 6.665, 10.55],
            [6.508, 7.931, 9.26],
            [6.459, 6.281, 7.458],
            [8.677, 7.014, 6.814],
            [8.683, 8.723, 8.552],
            [9.037, 1.366, 13.643],
            [8.667, 0.688, 14.28],
            [7.36, 0.727, 11.834],
            [6.931, 0.182, 12.541],
            [7.413, 0.172, 11.017],
            [7.356, 3.053, 14.489],
            [7.438, 3.792, 15.143],
            [6.963, 2.277, 14.958],
            [5.722, 2.567, 12.539],
            [5.158, 1.93, 13.065],
            [6.095, 2.161, 10.285],
            [4.852, 3.502, 11.696],
            [3.882, 3.371, 11.894],
            [6.168, 4.776, 13.125],
            [4.588, 3.741, 9.167],
            [4.645, 3.085, 8.427],
            [3.631, 3.931, 9.328],
            [4.659, 6.063, 11.714],
            [3.698, 5.878, 11.563],
            [4.725, 6.711, 12.46],
            [4.821, 6.278, 9.184],
            [3.85, 6.433, 9.0],
            [6.138, 5.002, 7.7],
            [5.743, 7.207, 8.292],
            [5.189, 7.83, 7.74],
            [6.135, 7.665, 10.54],
            [7.35, 6.644, 6.385],
            [6.955, 7.403, 5.888],
            [7.421, 5.881, 5.759],
            [7.331, 9.083, 8.945],
            [7.372, 9.674, 9.739],
            [6.904, 9.59, 8.21],
            [9.012, 8.381, 7.215],
            [8.648, 9.05, 6.567],
            [13.089, 1.614, 9.265],
            [13.072, 4.022, 7.044],
            [12.986, 5.724, 13.798],
            [13.079, 8.271, 11.565],
            [10.897, 2.696, 14.019],
            [10.881, 1.051, 12.256],
            [13.054, 1.871, 11.562],
            [13.121, 3.469, 13.42],
            [14.27, 4.83, 12.119],
            [14.418, 3.144, 10.364],
            [14.332, 4.963, 8.756],
            [14.387, 6.665, 10.55],
            [13.066, 7.931, 9.26],
            [13.115, 6.281, 7.458],
            [10.897, 7.014, 6.814],
            [10.891, 8.723, 8.552],
            [10.537, 1.366, 13.643],
            [10.907, 0.688, 14.28],
            [12.214, 0.727, 11.834],
            [12.643, 0.182, 12.541],
            [12.161, 0.172, 11.017],
            [12.218, 3.053, 14.489],
            [12.136, 3.792, 15.143],
            [12.612, 2.277, 14.958],
            [13.853, 2.567, 12.539],
            [14.416, 1.93, 13.065],
            [13.479, 2.161, 10.285],
            [14.722, 3.502, 11.696],
            [15.693, 3.371, 11.894],
            [13.406, 4.776, 13.125],
            [14.986, 3.741, 9.167],
            [14.929, 3.085, 8.427],
            [15.943, 3.931, 9.328],
            [14.916, 6.063, 11.714],
            [15.877, 5.878, 11.563],
            [14.849, 6.711, 12.46],
            [14.753, 6.278, 9.184],
            [15.724, 6.433, 9.0],
            [13.436, 5.002, 7.7],
            [13.831, 7.207, 8.292],
            [14.385, 7.83, 7.74],
            [13.44, 7.665, 10.54],
            [12.224, 6.644, 6.385],
            [12.619, 7.403, 5.888],
            [12.154, 5.881, 5.759],
            [12.244, 9.083, 8.945],
            [12.203, 9.674, 9.739],
            [12.67, 9.59, 8.21],
            [10.562, 8.381, 7.215],
            [10.926, 9.05, 6.567],
            [9.787, 0.45, 10.315],
            [9.787, 5.13, 6.113],
            [9.787, 4.517, 14.944],
            [9.787, 9.497, 10.415],
            [9.787, 0.808, 11.484],
            [9.787, 3.439, 14.403],
            [9.787, 6.284, 6.55],
            [9.787, 9.025, 9.293],
        ],
    ),
}

case_3 = {
    "elements": np.array(
        [
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
        ],
    ),
    "coordinates": np.array(
        [
            [4.75, 9.42, 24.876],
            [3.59, 9.522, 24.158],
            [3.29, 8.767, 23.667],
            [2.804, 10.732, 24.122],
            [3.269, 11.814, 24.924],
            [2.712, 12.575, 25.032],
            [4.551, 11.798, 25.584],
            [5.27, 10.552, 25.584],
            [6.092, 10.48, 26.055],
            [5.774, 8.214, 24.65],
            [6.837, 8.008, 25.542],
            [6.841, 8.418, 26.399],
            [7.891, 7.182, 25.142],
            [8.627, 7.066, 25.731],
            [7.907, 6.531, 23.932],
            [6.729, 6.619, 23.167],
            [6.648, 6.068, 22.396],
            [5.671, 7.481, 23.485],
            [4.912, 7.557, 22.922],
            [9.167, 5.918, 23.298],
            [10.399, 6.611, 23.398],
            [10.498, 7.286, 24.061],
            [11.456, 6.329, 22.562],
            [12.277, 6.796, 22.675],
            [11.34, 5.341, 21.52],
            [10.146, 4.522, 21.576],
            [10.096, 3.76, 21.01],
            [9.061, 4.796, 22.425],
            [8.281, 4.251, 22.415],
            [12.223, 5.405, 20.316],
            [13.504, 6.054, 20.258],
            [13.991, 6.209, 21.06],
            [14.03, 6.453, 19.056],
            [14.879, 6.88, 19.066],
            [13.442, 6.291, 17.875],
            [12.253, 5.477, 17.835],
            [11.86, 5.241, 17.004],
            [11.686, 5.041, 19.043],
            [10.919, 4.484, 19.011],
            [13.752, 7.152, 16.665],
            [14.819, 8.03, 16.62],
            [15.565, 7.865, 17.186],
            [14.862, 9.162, 15.773],
            [15.637, 9.71, 15.752],
            [13.794, 9.472, 14.984],
            [12.812, 8.498, 14.792],
            [12.158, 8.611, 14.114],
            [12.792, 7.312, 15.634],
            [12.134, 6.643, 15.492],
            [1.851, 10.999, 23.03],
            [1.779, 12.217, 22.338],
            [1.993, 13.002, 22.828],
            [1.439, 12.377, 21.057],
            [1.422, 13.246, 20.673],
            [1.11, 11.261, 20.284],
            [0.88, 10.023, 20.963],
            [0.47, 9.3, 20.502],
            [1.249, 9.879, 22.27],
            [1.119, 9.041, 22.701],
            [1.37, 11.329, 18.74],
            [1.37, 12.561, 18.051],
            [0.936, 13.319, 18.427],
            [2.004, 12.655, 16.825],
            [2.003, 13.495, 16.378],
            [2.66, 11.552, 16.199],
            [2.521, 10.322, 16.823],
            [2.892, 9.548, 16.412],
            [1.838, 10.187, 18.067],
            [1.697, 9.326, 18.44],
            [3.717, 11.764, 15.116],
            [3.986, 13.03, 14.569],
            [3.39, 13.753, 14.719],
            [5.167, 13.222, 13.774],
            [5.33, 14.086, 13.417],
            [6.102, 12.197, 13.501],
            [5.749, 10.939, 13.974],
            [6.31, 10.201, 13.759],
            [4.602, 10.7, 14.758],
            [4.412, 9.817, 15.053],
            [7.479, 12.461, 13.019],
            [8.178, 13.657, 13.346],
            [7.675, 14.432, 13.564],
            [9.57, 13.737, 13.356],
            [9.995, 14.563, 13.559],
            [10.334, 12.619, 13.069],
            [9.687, 11.514, 12.488],
            [10.208, 10.812, 12.112],
            [8.286, 11.425, 12.449],
            [7.871, 10.674, 12.044],
            [5.303, 13.024, 25.934],
            [6.393, 12.988, 26.828],
            [6.487, 12.243, 27.409],
            [7.351, 14.024, 26.881],
            [8.035, 14.016, 27.541],
            [7.27, 15.072, 25.939],
            [6.106, 15.24, 25.166],
            [5.961, 16.013, 24.637],
            [5.139, 14.148, 25.229],
            [4.334, 14.242, 24.732],
            [8.495, 15.829, 25.466],
            [9.721, 15.158, 25.487],
            [9.85, 14.428, 26.081],
            [10.77, 15.56, 24.632],
            [11.572, 15.052, 24.603],
            [10.639, 16.758, 23.782],
            [9.469, 17.492, 23.953],
            [9.371, 18.303, 23.469],
            [8.445, 17.099, 24.784],
            [7.699, 17.672, 24.913],
            [11.574, 16.873, 22.607],
            [12.848, 16.27, 22.588],
            [13.258, 16.021, 23.409],
            [13.531, 16.027, 21.37],
            [14.376, 15.592, 21.389],
            [12.989, 16.408, 20.153],
            [11.774, 17.149, 20.174],
            [11.417, 17.488, 19.361],
            [11.101, 17.384, 21.376],
            [10.302, 17.898, 21.365],
            [13.443, 15.737, 18.893],
            [13.817, 14.34, 18.964],
            [14.033, 13.948, 19.8],
            [13.863, 13.555, 17.767],
            [14.024, 12.621, 17.827],
            [13.669, 14.156, 16.483],
            [13.459, 15.486, 16.41],
            [13.371, 15.899, 15.558],
            [13.36, 16.336, 17.667],
            [13.241, 17.275, 17.601],
            [13.446, 10.898, 14.519],
            [12.4, 11.141, 13.624],
            [12.112, 10.466, 13.019],
            [11.749, 12.475, 13.635],
            [12.325, 13.503, 14.477],
            [11.954, 14.378, 14.456],
            [13.424, 13.24, 15.329],
            [14.035, 11.93, 15.316],
            [14.816, 11.758, 15.829],
        ],
    ),
}

case_4 = {
    "elements": np.array(
        [
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
        ],
    ),
    "coordinates": np.array(
        [
            [11.496, 13.515, 17.91],
            [11.069, 15.133, 15.579],
            [10.304, 14.027, 15.915],
            [10.627, 13.212, 17.085],
            [11.693, 12.648, 19.061],
            [11.423, 13.456, 20.321],
            [11.696, 12.616, 21.561],
            [11.805, 15.351, 16.105],
            [10.153, 12.422, 17.214],
            [11.076, 11.889, 19.014],
            [10.498, 13.752, 20.326],
            [11.991, 14.243, 20.331],
            [11.51, 13.134, 22.36],
            [11.115, 11.837, 21.566],
            [13.304, 11.285, 17.91],
            [13.731, 9.667, 15.579],
            [14.496, 10.773, 15.915],
            [14.173, 11.588, 17.085],
            [13.107, 12.152, 19.061],
            [13.377, 11.344, 20.321],
            [13.104, 12.184, 21.561],
            [12.995, 9.449, 16.105],
            [14.647, 12.378, 17.214],
            [13.724, 12.911, 19.014],
            [14.302, 11.048, 20.326],
            [12.809, 10.557, 20.331],
            [13.29, 11.666, 22.36],
            [13.685, 12.963, 21.566],
            [11.496, 11.285, 6.89],
            [11.069, 9.667, 9.221],
            [10.304, 10.773, 8.885],
            [10.627, 11.588, 7.715],
            [11.693, 12.152, 5.739],
            [11.423, 11.344, 4.479],
            [11.696, 12.184, 3.239],
            [11.805, 9.449, 8.695],
            [10.153, 12.378, 7.586],
            [11.076, 12.911, 5.786],
            [10.498, 11.048, 4.474],
            [11.991, 10.557, 4.469],
            [11.51, 11.666, 2.44],
            [11.115, 12.963, 3.234],
            [13.304, 13.515, 6.89],
            [13.731, 15.133, 9.221],
            [14.496, 14.027, 8.885],
            [14.173, 13.212, 7.715],
            [13.107, 12.648, 5.739],
            [13.377, 13.456, 4.479],
            [13.104, 12.616, 3.239],
            [12.995, 15.351, 8.695],
            [14.647, 12.422, 7.586],
            [13.724, 11.889, 5.786],
            [14.302, 13.752, 4.474],
            [12.809, 14.243, 4.469],
            [13.29, 13.134, 2.44],
            [13.685, 11.837, 3.234],
            [13.515, 6.89, 13.304],
            [15.133, 9.221, 13.731],
            [14.027, 8.885, 14.496],
            [13.212, 7.715, 14.173],
            [12.648, 5.739, 13.107],
            [13.456, 4.479, 13.377],
            [12.616, 3.239, 13.104],
            [15.351, 8.695, 12.995],
            [12.422, 7.586, 14.647],
            [11.889, 5.786, 13.724],
            [13.752, 4.474, 14.302],
            [14.243, 4.469, 12.809],
            [13.134, 2.44, 13.29],
            [11.837, 3.234, 13.685],
            [11.285, 6.89, 11.496],
            [9.667, 9.221, 11.069],
            [10.773, 8.885, 10.304],
            [11.588, 7.715, 10.627],
            [12.152, 5.739, 11.693],
            [11.344, 4.479, 11.423],
            [12.184, 3.239, 11.696],
            [9.449, 8.695, 11.805],
            [12.378, 7.586, 10.153],
            [12.911, 5.786, 11.076],
            [11.048, 4.474, 10.498],
            [10.557, 4.469, 11.991],
            [11.666, 2.44, 11.51],
            [12.963, 3.234, 11.115],
            [11.285, 17.91, 13.304],
            [9.667, 15.579, 13.731],
            [10.773, 15.915, 14.496],
            [11.588, 17.085, 14.173],
            [12.152, 19.061, 13.107],
            [11.344, 20.321, 13.377],
            [12.184, 21.561, 13.104],
            [9.449, 16.105, 12.995],
            [12.378, 17.214, 14.647],
            [12.911, 19.014, 13.724],
            [11.048, 20.326, 14.302],
            [10.557, 20.331, 12.809],
            [11.666, 22.36, 13.29],
            [12.963, 21.566, 13.685],
            [13.515, 17.91, 11.496],
            [15.133, 15.579, 11.069],
            [14.027, 15.915, 10.304],
            [13.212, 17.085, 10.627],
            [12.648, 19.061, 11.693],
            [13.456, 20.321, 11.423],
            [12.616, 21.561, 11.696],
            [15.351, 16.105, 11.805],
            [12.422, 17.214, 10.153],
            [11.889, 19.014, 11.076],
            [13.752, 20.326, 10.498],
            [14.243, 20.331, 11.991],
            [13.134, 22.36, 11.51],
            [11.837, 21.566, 11.115],
            [6.89, 11.496, 11.285],
            [9.221, 11.069, 9.667],
            [8.885, 10.304, 10.773],
            [7.715, 10.627, 11.588],
            [5.739, 11.693, 12.152],
            [4.479, 11.423, 11.344],
            [3.239, 11.696, 12.184],
            [8.695, 11.805, 9.449],
            [7.586, 10.153, 12.378],
            [5.786, 11.076, 12.911],
            [4.474, 10.498, 11.048],
            [4.469, 11.991, 10.557],
            [2.44, 11.51, 11.666],
            [3.234, 11.115, 12.963],
            [6.89, 13.304, 13.515],
            [9.221, 13.731, 15.133],
            [8.885, 14.496, 14.027],
            [7.715, 14.173, 13.212],
            [5.739, 13.107, 12.648],
            [4.479, 13.377, 13.456],
            [3.239, 13.104, 12.616],
            [8.695, 12.995, 15.351],
            [7.586, 14.647, 12.422],
            [5.786, 13.724, 11.889],
            [4.474, 14.302, 13.752],
            [4.469, 12.809, 14.243],
            [2.44, 13.29, 13.134],
            [3.234, 13.685, 11.837],
            [17.91, 11.496, 13.515],
            [15.579, 11.069, 15.133],
            [15.915, 10.304, 14.027],
            [17.085, 10.627, 13.212],
            [19.061, 11.693, 12.648],
            [20.321, 11.423, 13.456],
            [21.561, 11.696, 12.616],
            [16.105, 11.805, 15.351],
            [17.214, 10.153, 12.422],
            [19.014, 11.076, 11.889],
            [20.326, 10.498, 13.752],
            [20.331, 11.991, 14.243],
            [22.36, 11.51, 13.134],
            [21.566, 11.115, 11.837],
            [17.91, 13.304, 11.285],
            [15.579, 13.731, 9.667],
            [15.915, 14.496, 10.773],
            [17.085, 14.173, 11.588],
            [19.061, 13.107, 12.152],
            [20.321, 13.377, 11.344],
            [21.561, 13.104, 12.184],
            [16.105, 12.995, 9.449],
            [17.214, 14.647, 12.378],
            [19.014, 13.724, 12.911],
            [20.326, 14.302, 11.048],
            [20.331, 12.809, 10.557],
            [22.36, 13.29, 11.666],
            [21.566, 13.685, 12.963],
        ],
    ),
}

case_5 = {
    "elements": np.array(
        [
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "C",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "C",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "C",
            "C",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "N",
            "N",
            "N",
            "N",
            "N",
            "N",
            "O",
            "H",
            "O",
            "H",
            "O",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "C",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "C",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "C",
            "C",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "N",
            "N",
            "N",
            "N",
            "N",
            "N",
            "O",
            "H",
            "O",
            "H",
            "O",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "C",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "C",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "C",
            "C",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "N",
            "N",
            "N",
            "N",
            "N",
            "N",
            "O",
            "H",
            "O",
            "H",
            "O",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "C",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "H",
            "C",
            "H",
            "C",
            "C",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "C",
            "C",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "C",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "H",
            "H",
            "C",
            "H",
            "C",
            "H",
            "N",
            "N",
            "N",
            "N",
            "N",
            "N",
            "O",
            "H",
            "O",
            "H",
            "O",
            "H",
        ],
    ),
    "coordinates": np.array(
        [
            [5.476, 15.583, -6.489],
            [4.744, 15.782, -7.141],
            [5.958, 14.204, -6.751],
            [6.221, 14.142, -7.704],
            [6.773, 14.052, -6.209],
            [5.02, 13.147, -6.468],
            [4.249, 13.221, -7.1],
            [4.507, 13.203, -5.074],
            [5.247, 12.992, -4.449],
            [3.808, 12.512, -4.961],
            [3.878, 14.675, -4.683],
            [3.037, 14.815, -5.207],
            [4.917, 15.774, -5.092],
            [4.481, 16.663, -5.038],
            [5.664, 15.766, -4.442],
            [6.358, 17.47, -7.47],
            [5.525, 17.55, -7.922],
            [7.418, 18.495, -7.73],
            [8.627, 18.455, -7.044],
            [9.596, 19.422, -7.29],
            [9.356, 20.427, -8.22],
            [10.019, 21.088, -8.387],
            [8.147, 20.466, -8.905],
            [7.178, 19.499, -8.659],
            [6.35, 19.525, -9.127],
            [7.879, 21.652, -9.988],
            [8.392, 22.877, -9.387],
            [9.336, 22.756, -9.153],
            [7.879, 23.083, -8.577],
            [8.307, 23.614, -10.024],
            [8.769, 21.072, -11.252],
            [8.379, 20.229, -11.563],
            [9.689, 20.92, -10.959],
            [8.761, 21.724, -11.984],
            [6.43, 21.611, -10.363],
            [6.208, 20.721, -10.71],
            [6.252, 22.284, -11.054],
            [5.881, 21.799, -9.574],
            [10.836, 19.425, -6.535],
            [10.937, 18.7, -5.929],
            [12.881, 19.917, -5.765],
            [12.734, 19.151, -5.14],
            [14.157, 19.693, -6.574],
            [14.026, 18.932, -7.193],
            [14.353, 20.5, -7.116],
            [15.325, 19.404, -5.649],
            [15.137, 18.594, -5.092],
            [15.552, 20.629, -4.752],
            [16.336, 20.477, -4.167],
            [15.735, 21.423, -5.312],
            [14.382, 20.861, -3.948],
            [14.149, 20.038, -3.429],
            [13.134, 21.299, -4.901],
            [13.379, 22.054, -5.492],
            [12.337, 21.544, -4.367],
            [14.547, 21.838, -1.724],
            [14.459, 20.959, -1.374],
            [14.688, 22.97, -0.825],
            [14.737, 22.661, 0.529],
            [14.967, 23.666, 1.462],
            [15.142, 24.978, 1.04],
            [15.299, 25.664, 1.68],
            [15.093, 25.287, -0.313],
            [14.866, 24.282, -1.246],
            [14.83, 24.493, -2.171],
            [15.261, 26.716, -0.855],
            [14.977, 27.193, -2.194],
            [15.168, 28.152, -2.245],
            [14.033, 27.036, -2.402],
            [15.539, 26.713, -2.836],
            [16.88, 27.046, -0.475],
            [17.107, 27.951, -0.771],
            [17.46, 26.399, -0.93],
            [17.009, 26.976, 0.493],
            [14.585, 27.76, 0.249],
            [14.665, 28.681, -0.08],
            [15.052, 27.678, 1.105],
            [13.636, 27.538, 0.372],
            [17.212, 18.117, -6.309],
            [16.916, 17.524, -5.628],
            [18.363, 17.728, -7.113],
            [18.942, 16.48, -6.91],
            [20.054, 16.101, -7.655],
            [20.583, 16.968, -8.603],
            [21.34, 16.71, -9.114],
            [20.002, 18.215, -8.807],
            [18.893, 18.595, -8.061],
            [18.496, 19.448, -8.2],
            [20.6, 19.154, -9.944],
            [19.641, 20.44, -9.962],
            [18.721, 20.159, -10.142],
            [19.938, 21.059, -10.663],
            [19.682, 20.892, -9.091],
            [22.067, 19.386, -9.739],
            [22.534, 18.522, -9.716],
            [22.209, 19.855, -8.891],
            [22.418, 19.927, -10.476],
            [20.458, 18.504, -11.221],
            [19.512, 18.319, -11.39],
            [20.961, 17.664, -11.216],
            [20.809, 19.089, -11.925],
            [2.362, 14.918, -2.947],
            [1.671, 15.065, -3.581],
            [5.028, 10.883, -7.501],
            [4.236, 11.074, -7.989],
            [6.527, 16.54, -6.702],
            [3.55, 14.668, -3.283],
            [5.579, 11.793, -6.566],
            [11.687, 20.144, -6.556],
            [16.589, 19.2, -6.468],
            [14.539, 22.034, -3.018],
            [8.925, 17.451, -6.183],
            [8.276, 16.916, -6.178],
            [14.535, 21.316, 0.868],
            [14.108, 21.263, 1.588],
            [18.403, 15.716, -5.93],
            [18.875, 15.024, -5.878],
            [20.306, 10.2, -6.489],
            [21.039, 10.001, -7.141],
            [19.824, 11.579, -6.751],
            [19.561, 11.641, -7.704],
            [19.01, 11.731, -6.209],
            [20.763, 12.636, -6.468],
            [21.534, 12.561, -7.1],
            [21.276, 12.579, -5.074],
            [20.536, 12.791, -4.449],
            [21.975, 13.27, -4.961],
            [21.905, 11.107, -4.683],
            [22.745, 10.968, -5.207],
            [20.866, 10.009, -5.092],
            [21.302, 9.119, -5.038],
            [20.118, 10.017, -4.442],
            [19.425, 8.312, -7.47],
            [20.257, 8.232, -7.922],
            [18.365, 7.288, -7.73],
            [17.155, 7.327, -7.044],
            [16.187, 6.361, -7.29],
            [16.427, 5.356, -8.22],
            [15.763, 4.695, -8.387],
            [17.635, 5.317, -8.905],
            [18.605, 6.283, -8.659],
            [19.432, 6.257, -9.127],
            [17.903, 4.13, -9.988],
            [17.39, 2.906, -9.387],
            [16.447, 3.027, -9.153],
            [17.903, 2.699, -8.577],
            [17.475, 2.168, -10.024],
            [17.014, 4.71, -11.252],
            [17.403, 5.554, -11.563],
            [16.093, 4.863, -10.959],
            [17.022, 4.058, -11.984],
            [19.352, 4.172, -10.363],
            [19.574, 5.061, -10.71],
            [19.53, 3.499, -11.054],
            [19.902, 3.983, -9.574],
            [14.946, 6.358, -6.535],
            [14.846, 7.082, -5.929],
            [12.902, 5.866, -5.765],
            [13.049, 6.631, -5.14],
            [11.625, 6.09, -6.574],
            [11.757, 6.85, -7.193],
            [11.429, 5.283, -7.116],
            [10.457, 6.379, -5.649],
            [10.646, 7.188, -5.092],
            [10.231, 5.154, -4.752],
            [9.447, 5.306, -4.167],
            [10.047, 4.36, -5.312],
            [11.401, 4.922, -3.948],
            [11.633, 5.744, -3.429],
            [12.649, 4.484, -4.901],
            [12.404, 3.728, -5.492],
            [13.446, 4.239, -4.367],
            [11.236, 3.945, -1.724],
            [11.324, 4.824, -1.374],
            [11.094, 2.813, -0.825],
            [11.045, 3.121, 0.529],
            [10.816, 2.117, 1.462],
            [10.64, 0.804, 1.04],
            [10.483, 0.119, 1.68],
            [10.689, 0.496, -0.313],
            [10.916, 1.501, -1.246],
            [10.952, 1.289, -2.171],
            [10.522, -0.933, -0.855],
            [10.805, -1.41, -2.194],
            [10.615, -2.369, -2.245],
            [11.749, -1.253, -2.402],
            [10.243, -0.931, -2.836],
            [8.903, -1.263, -0.475],
            [8.676, -2.168, -0.771],
            [8.323, -0.616, -0.93],
            [8.774, -1.194, 0.493],
            [11.197, -1.978, 0.249],
            [11.117, -2.898, -0.08],
            [10.731, -1.895, 1.105],
            [12.146, -1.756, 0.372],
            [8.57, 7.665, -6.309],
            [8.867, 8.258, -5.628],
            [7.42, 8.054, -7.113],
            [6.84, 9.302, -6.91],
            [5.729, 9.682, -7.655],
            [5.2, 8.815, -8.603],
            [4.442, 9.073, -9.114],
            [5.78, 7.568, -8.807],
            [6.889, 7.188, -8.061],
            [7.286, 6.335, -8.2],
            [5.182, 6.629, -9.944],
            [6.141, 5.342, -9.962],
            [7.062, 5.623, -10.142],
            [5.845, 4.723, -10.663],
            [6.1, 4.891, -9.091],
            [3.715, 6.397, -9.739],
            [3.249, 7.26, -9.716],
            [3.573, 5.927, -8.891],
            [3.365, 5.855, -10.476],
            [5.324, 7.278, -11.221],
            [6.27, 7.464, -11.39],
            [4.821, 8.119, -11.216],
            [4.973, 6.693, -11.925],
            [23.421, 10.865, -2.947],
            [24.112, 10.718, -3.581],
            [20.755, 14.9, -7.501],
            [21.547, 14.709, -7.989],
            [19.255, 9.243, -6.702],
            [22.232, 11.115, -3.283],
            [20.203, 13.99, -6.566],
            [14.095, 5.639, -6.556],
            [9.194, 6.582, -6.468],
            [11.244, 3.749, -3.018],
            [16.858, 8.331, -6.183],
            [17.506, 8.867, -6.178],
            [11.247, 4.467, 0.868],
            [11.674, 4.52, 1.588],
            [7.379, 10.067, -5.93],
            [6.907, 10.759, -5.878],
            [15.583, 20.306, 6.489],
            [15.782, 21.039, 7.141],
            [14.204, 19.824, 6.751],
            [14.142, 19.561, 7.704],
            [14.052, 19.01, 6.209],
            [13.147, 20.763, 6.468],
            [13.221, 21.534, 7.1],
            [13.203, 21.276, 5.074],
            [12.992, 20.536, 4.449],
            [12.512, 21.975, 4.961],
            [14.675, 21.905, 4.683],
            [14.815, 22.745, 5.207],
            [15.774, 20.866, 5.092],
            [16.663, 21.302, 5.038],
            [15.766, 20.118, 4.442],
            [17.47, 19.425, 7.47],
            [17.55, 20.257, 7.922],
            [18.495, 18.365, 7.73],
            [18.455, 17.155, 7.044],
            [19.422, 16.187, 7.29],
            [20.427, 16.427, 8.22],
            [21.088, 15.763, 8.387],
            [20.466, 17.635, 8.905],
            [19.499, 18.605, 8.659],
            [19.525, 19.432, 9.127],
            [21.652, 17.903, 9.988],
            [22.877, 17.39, 9.387],
            [22.756, 16.447, 9.153],
            [23.083, 17.903, 8.577],
            [23.614, 17.475, 10.024],
            [21.072, 17.014, 11.252],
            [20.229, 17.403, 11.563],
            [20.92, 16.093, 10.959],
            [21.724, 17.022, 11.984],
            [21.611, 19.352, 10.363],
            [20.721, 19.574, 10.71],
            [22.284, 19.53, 11.054],
            [21.799, 19.902, 9.574],
            [19.425, 14.946, 6.535],
            [18.7, 14.846, 5.929],
            [19.917, 12.902, 5.765],
            [19.151, 13.049, 5.14],
            [19.693, 11.625, 6.574],
            [18.932, 11.757, 7.193],
            [20.5, 11.429, 7.116],
            [19.404, 10.457, 5.649],
            [18.594, 10.646, 5.092],
            [20.629, 10.231, 4.752],
            [20.477, 9.447, 4.167],
            [21.423, 10.047, 5.312],
            [20.861, 11.401, 3.948],
            [20.038, 11.633, 3.429],
            [21.299, 12.649, 4.901],
            [22.054, 12.404, 5.492],
            [21.544, 13.446, 4.367],
            [21.838, 11.236, 1.724],
            [20.959, 11.324, 1.374],
            [22.97, 11.094, 0.825],
            [22.661, 11.045, -0.529],
            [23.666, 10.816, -1.462],
            [24.978, 10.64, -1.04],
            [25.664, 10.483, -1.68],
            [25.287, 10.689, 0.313],
            [24.282, 10.916, 1.246],
            [24.493, 10.952, 2.171],
            [26.716, 10.522, 0.855],
            [27.193, 10.805, 2.194],
            [28.152, 10.615, 2.245],
            [27.036, 11.749, 2.402],
            [26.713, 10.243, 2.836],
            [27.046, 8.903, 0.475],
            [27.951, 8.676, 0.771],
            [26.399, 8.323, 0.93],
            [26.976, 8.774, -0.493],
            [27.76, 11.197, -0.249],
            [28.681, 11.117, 0.08],
            [27.678, 10.731, -1.105],
            [27.538, 12.146, -0.372],
            [18.117, 8.57, 6.309],
            [17.524, 8.867, 5.628],
            [17.728, 7.42, 7.113],
            [16.48, 6.84, 6.91],
            [16.101, 5.729, 7.655],
            [16.968, 5.2, 8.603],
            [16.71, 4.442, 9.114],
            [18.215, 5.78, 8.807],
            [18.595, 6.889, 8.061],
            [19.448, 7.286, 8.2],
            [19.154, 5.182, 9.944],
            [20.44, 6.141, 9.962],
            [20.159, 7.062, 10.142],
            [21.059, 5.845, 10.663],
            [20.892, 6.1, 9.091],
            [19.386, 3.715, 9.739],
            [18.522, 3.249, 9.716],
            [19.855, 3.573, 8.891],
            [19.927, 3.365, 10.476],
            [18.504, 5.324, 11.221],
            [18.319, 6.27, 11.39],
            [17.664, 4.821, 11.216],
            [19.089, 4.973, 11.925],
            [14.918, 23.421, 2.947],
            [15.065, 24.112, 3.581],
            [10.883, 20.755, 7.501],
            [11.074, 21.547, 7.989],
            [16.54, 19.255, 6.702],
            [14.668, 22.232, 3.283],
            [11.793, 20.203, 6.566],
            [20.144, 14.095, 6.556],
            [19.2, 9.194, 6.468],
            [22.034, 11.244, 3.018],
            [17.451, 16.858, 6.183],
            [16.916, 17.506, 6.178],
            [21.316, 11.247, -0.868],
            [21.263, 11.674, -1.588],
            [15.716, 7.379, 5.93],
            [15.024, 6.907, 5.878],
            [10.2, 5.476, 6.489],
            [10.001, 4.744, 7.141],
            [11.579, 5.958, 6.751],
            [11.641, 6.221, 7.704],
            [11.731, 6.773, 6.209],
            [12.636, 5.02, 6.468],
            [12.561, 4.249, 7.1],
            [12.579, 4.507, 5.074],
            [12.791, 5.247, 4.449],
            [13.27, 3.808, 4.961],
            [11.107, 3.878, 4.683],
            [10.968, 3.037, 5.207],
            [10.009, 4.917, 5.092],
            [9.119, 4.481, 5.038],
            [10.017, 5.664, 4.442],
            [8.312, 6.358, 7.47],
            [8.232, 5.525, 7.922],
            [7.288, 7.418, 7.73],
            [7.327, 8.627, 7.044],
            [6.361, 9.596, 7.29],
            [5.356, 9.356, 8.22],
            [4.695, 10.019, 8.387],
            [5.317, 8.147, 8.905],
            [6.283, 7.178, 8.659],
            [6.257, 6.35, 9.127],
            [4.13, 7.879, 9.988],
            [2.906, 8.392, 9.387],
            [3.027, 9.336, 9.153],
            [2.699, 7.879, 8.577],
            [2.168, 8.307, 10.024],
            [4.71, 8.769, 11.252],
            [5.554, 8.379, 11.563],
            [4.863, 9.689, 10.959],
            [4.058, 8.761, 11.984],
            [4.172, 6.43, 10.363],
            [5.061, 6.208, 10.71],
            [3.499, 6.252, 11.054],
            [3.983, 5.881, 9.574],
            [6.358, 10.836, 6.535],
            [7.082, 10.937, 5.929],
            [5.866, 12.881, 5.765],
            [6.631, 12.734, 5.14],
            [6.09, 14.157, 6.574],
            [6.85, 14.026, 7.193],
            [5.283, 14.353, 7.116],
            [6.379, 15.325, 5.649],
            [7.188, 15.137, 5.092],
            [5.154, 15.552, 4.752],
            [5.306, 16.336, 4.167],
            [4.36, 15.735, 5.312],
            [4.922, 14.382, 3.948],
            [5.744, 14.149, 3.429],
            [4.484, 13.134, 4.901],
            [3.728, 13.379, 5.492],
            [4.239, 12.337, 4.367],
            [3.945, 14.547, 1.724],
            [4.824, 14.459, 1.374],
            [2.813, 14.688, 0.825],
            [3.121, 14.737, -0.529],
            [2.117, 14.967, -1.462],
            [0.804, 15.142, -1.04],
            [0.119, 15.299, -1.68],
            [0.496, 15.093, 0.313],
            [1.501, 14.866, 1.246],
            [1.289, 14.83, 2.171],
            [-0.933, 15.261, 0.855],
            [-1.41, 14.977, 2.194],
            [-2.369, 15.168, 2.245],
            [-1.253, 14.033, 2.402],
            [-0.931, 15.539, 2.836],
            [-1.263, 16.88, 0.475],
            [-2.168, 17.107, 0.771],
            [-0.616, 17.46, 0.93],
            [-1.194, 17.009, -0.493],
            [-1.978, 14.585, -0.249],
            [-2.898, 14.665, 0.08],
            [-1.895, 15.052, -1.105],
            [-1.756, 13.636, -0.372],
            [7.665, 17.212, 6.309],
            [8.258, 16.916, 5.628],
            [8.054, 18.363, 7.113],
            [9.302, 18.942, 6.91],
            [9.682, 20.054, 7.655],
            [8.815, 20.583, 8.603],
            [9.073, 21.34, 9.114],
            [7.568, 20.002, 8.807],
            [7.188, 18.893, 8.061],
            [6.335, 18.496, 8.2],
            [6.629, 20.6, 9.944],
            [5.342, 19.641, 9.962],
            [5.623, 18.721, 10.142],
            [4.723, 19.938, 10.663],
            [4.891, 19.682, 9.091],
            [6.397, 22.067, 9.739],
            [7.26, 22.534, 9.716],
            [5.927, 22.209, 8.891],
            [5.855, 22.418, 10.476],
            [7.278, 20.458, 11.221],
            [7.464, 19.512, 11.39],
            [8.119, 20.961, 11.216],
            [6.693, 20.809, 11.925],
            [10.865, 2.362, 2.947],
            [10.718, 1.671, 3.581],
            [14.9, 5.028, 7.501],
            [14.709, 4.236, 7.989],
            [9.243, 6.527, 6.702],
            [11.115, 3.55, 3.283],
            [13.99, 5.579, 6.566],
            [5.639, 11.687, 6.556],
            [6.582, 16.589, 6.468],
            [3.749, 14.539, 3.018],
            [8.331, 8.925, 6.183],
            [8.867, 8.276, 6.178],
            [4.467, 14.535, -0.868],
            [4.52, 14.108, -1.588],
            [10.067, 18.403, 5.93],
            [10.759, 18.875, 5.878],
        ],
    ),
}

results_2 = {
    "windows_diam": np.array([3.72937988, 3.34146021]),
    "windows_coms": np.array(
        [
            [9.50377026, 7.1542064, 12.84136045],
            [9.25703433, 2.72286828, 8.13923095],
        ]
    ),
}

results_3 = {
    "windows_diam": np.array([6.5036498, 7.90390212, 7.26955977]),
    "windows_coms": np.array(
        [
            [11.83772373, 11.26384234, 22.41304403],
            [6.14465038, 15.40381028, 19.5164307],
            [6.80395224, 6.7378818, 17.72154653],
        ]
    ),
}

results_4 = {
    "windows_diam": np.array([3.63778746, 3.63562103, 3.63707237, 3.62896512]),
    "windows_coms": np.array(
        [
            [10.77105705, 10.77097707, 14.02893956],
            [14.01544846, 14.0154126, 14.01539845],
            [10.77542236, 14.02453217, 10.77546634],
            [13.92965524, 10.87029766, 10.87034163],
        ]
    ),
}

results_5 = {
    "windows_diam": np.array(
        [
            9.05947325,
            9.17248589,
            9.17507442,
            9.16546517,
            9.19219132,
            9.05399606,
        ]
    ),
    "windows_coms": np.array(
        [
            [13.00078906, 12.76528039, 6.39425789],
            [18.14168412, 16.3658928, 0.13593408],
            [16.38472655, 7.61300061, -0.13630524],
            [7.75762105, 9.4938187, 0.13394709],
            [9.30996749, 18.2985819, -0.13816486],
            [13.01415074, 12.99779223, -6.30126185],
        ]
    ),
}


class TestWindows(unittest.TestCase):
    """Validating finding windows (diameters, COMs, Total number found)."""

    def test_case_1(self):
        """Case with no windows."""
        molsys = pw.MolecularSystem.load_system(case_1, "case_1")
        mol = molsys.system_to_molecule()
        windows = mol.calculate_windows()

        self.assertIsNone(windows)

    def _test_case_1_new(self):
        """Case with no windows."""
        molsys = pw.MolecularSystem.load_system(case_1, "case_1")
        mol = molsys.system_to_molecule()
        self.assertIsNone(mol.get_windows())

    def test_case_2(self):
        """Case with 2 windows."""
        molsys = pw.MolecularSystem.load_system(case_2, "case_2")
        mol = molsys.system_to_molecule()
        mol.calculate_windows()
        windows = mol.properties["windows"]["diameters"]
        coms = mol.properties["windows"]["centre_of_mass"]

        p = windows.argsort()
        p_ref = results_2["windows_diam"].argsort()

        np.testing.assert_almost_equal(
            windows[p], results_2["windows_diam"][p_ref], decimal=3
        )

        np.testing.assert_almost_equal(
            coms[p], results_2["windows_coms"][p_ref], decimal=3
        )

    def _test_case_2_new(self):
        """Case with 2 windows."""
        molsys = pw.MolecularSystem.load_system(case_2, "case_2")
        mol = molsys.system_to_molecule()
        windows = mol.get_windows()

        win = np.array([window.calculate_diameter() for window in windows])
        com = np.array(
            [window.calculate_centre_of_mass() for window in windows]
        )

        p = win.argsort()
        p_ref = results_2["windows_diam"].argsort()

        np.testing.assert_almost_equal(
            win[p], results_2["windows_diam"][p_ref], decimal=3
        )

        np.testing.assert_almost_equal(
            com[p], results_2["windows_coms"][p_ref], decimal=3
        )

    def test_case_3(self):
        """Case with 3 windows."""
        molsys = pw.MolecularSystem.load_system(case_3, "case_3")
        mol = molsys.system_to_molecule()
        mol.calculate_windows()
        windows = mol.properties["windows"]["diameters"]
        coms = mol.properties["windows"]["centre_of_mass"]

        p = windows.argsort()
        p_ref = results_3["windows_diam"].argsort()

        np.testing.assert_almost_equal(
            windows[p], results_3["windows_diam"][p_ref], decimal=3
        )

        np.testing.assert_almost_equal(
            coms[p], results_3["windows_coms"][p_ref], decimal=3
        )

    def _test_case_3_new(self):
        """Case with 3 windows."""
        molsys = pw.MolecularSystem.load_system(case_3, "case_3")
        mol = molsys.system_to_molecule()
        windows = mol.get_windows()

        win = np.array([window.calculate_diameter() for window in windows])
        com = np.array(
            [window.calculate_centre_of_mass() for window in windows]
        )

        p = win.argsort()
        p_ref = results_3["windows_diam"].argsort()

        np.testing.assert_almost_equal(
            win[p], results_3["windows_diam"][p_ref], decimal=3
        )

        np.testing.assert_almost_equal(
            com[p], results_3["windows_coms"][p_ref], decimal=3
        )

    def test_case_4(self):
        """Case with 4 windows."""
        molsys = pw.MolecularSystem.load_system(case_4, "case_4")
        mol = molsys.system_to_molecule()
        mol.calculate_windows()
        windows = mol.properties["windows"]["diameters"]
        coms = mol.properties["windows"]["centre_of_mass"]

        p = windows.argsort()
        p_ref = results_4["windows_diam"].argsort()

        np.testing.assert_almost_equal(
            windows[p], results_4["windows_diam"][p_ref], decimal=3
        )

        np.testing.assert_almost_equal(
            coms[p], results_4["windows_coms"][p_ref], decimal=3
        )

    def _test_case_4_new(self):
        """Case with 4 windows."""
        molsys = pw.MolecularSystem.load_system(case_4, "case_4")
        mol = molsys.system_to_molecule()
        windows = mol.get_windows()

        win = np.array([window.calculate_diameter() for window in windows])
        com = np.array(
            [window.calculate_centre_of_mass() for window in windows]
        )

        p = win.argsort()
        p_ref = results_4["windows_diam"].argsort()

        np.testing.assert_almost_equal(
            win[p], results_4["windows_diam"][p_ref], decimal=3
        )

        np.testing.assert_almost_equal(
            com[p], results_4["windows_coms"][p_ref], decimal=3
        )

    def test_case_5(self):
        """Case with 6 windows."""
        molsys = pw.MolecularSystem.load_system(case_5, "case_5")
        mol = molsys.system_to_molecule()
        mol.calculate_windows()
        windows = mol.properties["windows"]["diameters"]
        coms = mol.properties["windows"]["centre_of_mass"]

        p = windows.argsort()
        p_ref = results_5["windows_diam"].argsort()

        np.testing.assert_almost_equal(
            windows[p], results_5["windows_diam"][p_ref], decimal=3
        )

        np.testing.assert_almost_equal(
            coms[p], results_5["windows_coms"][p_ref], decimal=3
        )

    def _test_case_5_new(self):
        """Case with 6 windows."""
        molsys = pw.MolecularSystem.load_system(case_5, "case_5")
        mol = molsys.system_to_molecule()
        windows = mol.get_windows()

        win = np.array([window.calculate_diameter() for window in windows])
        com = np.array(
            [window.calculate_centre_of_mass() for window in windows]
        )

        p = win.argsort()
        p_ref = results_5["windows_diam"].argsort()

        np.testing.assert_almost_equal(
            win[p], results_5["windows_diam"][p_ref], decimal=3
        )

        np.testing.assert_almost_equal(
            com[p], results_5["windows_coms"][p_ref], decimal=3
        )


if __name__ == "__main__":
    unittest.main()
