import unittest

import numpy as np

import pywindow as pw

case_1 = {
    "elements": np.array(
        [
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "N",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "N",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
        ],
    ),
    "coordinates": np.array(
        [
            [-2.331, -1.122, -4.83],
            [-0.977, -0.403, -4.854],
            [0.217, -1.15, -4.848],
            [1.459, -0.488, -4.794],
            [1.51, 0.92, -4.809],
            [0.315, 1.665, -4.815],
            [-0.929, 1.006, -4.869],
            [-2.239, 1.826, -4.994],
            [-2.935, 2.238, -3.77],
            [0.367, 3.196, -4.748],
            [2.879, 1.646, -4.868],
            [3.541, 2.011, -3.611],
            [2.756, -1.3, -4.704],
            [0.165, -2.697, -4.95],
            [0.106, -3.486, -3.715],
            [-2.565, -1.153, 4.568],
            [-1.214, -0.435, 4.664],
            [-0.022, -1.183, 4.712],
            [1.222, -0.521, 4.723],
            [1.273, 0.886, 4.751],
            [0.078, 1.632, 4.703],
            [-1.167, 0.973, 4.691],
            [-2.481, 1.793, 4.757],
            [-3.116, 2.214, 3.503],
            [0.134, 3.164, 4.65],
            [2.637, 1.612, 4.882],
            [3.36, 1.986, 3.662],
            [2.522, -1.333, 4.692],
            [-0.079, -2.731, 4.8],
            [-0.076, -3.511, 3.558],
            [5.488, 3.084, 0.08],
            [4.903, 2.761, -1.142],
            [3.666, 2.102, -1.194],
            [3.028, 1.75, -2.47],
            [3.033, 1.777, 0.014],
            [3.605, 2.094, 1.256],
            [2.904, 1.732, 2.495],
            [4.843, 2.753, 1.269],
            [-4.984, 3.45, -0.178],
            [-4.423, 3.076, 1.041],
            [-3.234, 2.333, 1.087],
            [-2.622, 1.926, 2.36],
            [-2.625, 1.975, -0.124],
            [-3.173, 2.341, -1.363],
            [-2.498, 1.943, -2.606],
            [-4.363, 3.084, -1.37],
            [-0.066, -5.807, -0.088],
            [-0.011, -5.106, -1.291],
            [0.038, -3.704, -1.304],
            [0.097, -2.941, -2.558],
            [0.032, -3.026, -0.076],
            [-0.023, -3.713, 1.146],
            [-0.028, -2.958, 2.407],
            [-0.072, -5.114, 1.12],
            [-2.675, -1.315, -5.845],
            [-2.287, -2.068, -4.293],
            [-3.096, -0.547, -4.309],
            [-2.945, 1.279, -5.618],
            [-2.045, 2.718, -5.59],
            [0.406, 3.618, -5.752],
            [1.228, 3.557, -4.188],
            [-0.493, 3.617, -4.229],
            [3.575, 1.049, -5.457],
            [2.778, 2.548, -5.473],
            [2.619, -2.241, -4.172],
            [3.136, -1.519, -5.702],
            [3.532, -0.78, -4.145],
            [1.017, -3.044, -5.535],
            [-0.679, -2.985, -5.577],
            [-2.96, -1.353, 5.564],
            [-2.495, -2.097, 4.028],
            [-3.303, -0.575, 4.013],
            [-3.217, 1.241, 5.342],
            [-2.317, 2.681, 5.369],
            [1.022, 3.528, 4.135],
            [-0.7, 3.589, 4.092],
            [0.124, 3.578, 5.657],
            [3.303, 1.01, 5.501],
            [2.506, 2.509, 5.488],
            [2.411, -2.271, 4.149],
            [3.324, -0.81, 4.174],
            [2.853, -1.557, 5.705],
            [0.743, -3.082, 5.424],
            [-0.953, -3.022, 5.382],
            [6.442, 3.592, 0.106],
            [5.417, 3.026, -2.056],
            [2.072, 1.242, -2.367],
            [2.078, 1.269, -0.011],
            [1.954, 1.226, 2.342],
            [5.311, 3.011, 2.21],
            [-5.899, 4.022, -0.199],
            [-4.917, 3.368, 1.958],
            [-1.703, 1.355, 2.252],
            [-1.707, 1.401, -0.104],
            [-1.586, 1.37, -2.457],
            [-4.811, 3.382, -2.308],
            [-0.104, -6.886, -0.093],
            [-0.008, -5.659, -2.221],
            [0.131, -1.863, -2.426],
            [0.07, -1.944, -0.072],
            [0.013, -1.879, 2.283],
            [-0.115, -5.674, 2.045],
        ],
    ),
}

case_2 = {
    "elements": np.array(
        [
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "Si",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "Si",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "Si",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
        ],
    ),
    "coordinates": np.array(
        [
            [-4.19400000e00, 3.06500000e00, -4.67800000e00],
            [-4.78800000e00, 3.40000000e00, -3.38400000e00],
            [-2.88900000e00, 2.22500000e00, -4.71400000e00],
            [-2.95000000e00, 8.24000000e-01, -4.87200000e00],
            [-1.75900000e00, 7.50000000e-02, -5.00900000e00],
            [-5.08000000e-01, 7.30000000e-01, -4.97100000e00],
            [-4.46000000e-01, 2.12600000e00, -4.76800000e00],
            [-1.63700000e00, 2.87200000e00, -4.63400000e00],
            [-1.56900000e00, 4.38900000e00, -4.37200000e00],
            [-1.51000000e00, 5.23400000e00, -5.66000000e00],
            [9.34000000e-01, 2.83800000e00, -4.68300000e00],
            [1.60800000e00, 2.90200000e00, -3.38100000e00],
            [7.95000000e-01, -7.90000000e-02, -5.12800000e00],
            [1.26100000e00, -1.94000000e-01, -6.59100000e00],
            [-1.82100000e00, -1.45000000e00, -5.22500000e00],
            [-1.68800000e00, -2.15100000e00, -3.95400000e00],
            [-4.31600000e00, 1.13000000e-01, -4.87200000e00],
            [-4.91600000e00, -6.10000000e-02, -6.28100000e00],
            [-4.29900000e00, 5.60000000e-02, 3.84000000e00],
            [-4.49500000e00, 7.20000000e-01, 2.55700000e00],
            [-2.92800000e00, -6.48000000e-01, 3.87900000e00],
            [-2.82100000e00, -2.01800000e00, 3.54900000e00],
            [-1.57000000e00, -2.66700000e00, 3.62600000e00],
            [-4.15000000e-01, -1.93500000e00, 3.97400000e00],
            [-5.19000000e-01, -5.66000000e-01, 4.30100000e00],
            [-1.77800000e00, 7.40000000e-02, 4.26800000e00],
            [-1.88800000e00, 1.56600000e00, 4.63700000e00],
            [-2.14800000e00, 1.80100000e00, 6.13600000e00],
            [7.52000000e-01, 2.42000000e-01, 4.68800000e00],
            [1.46700000e00, 9.69000000e-01, 3.63200000e00],
            [9.63000000e-01, -2.62300000e00, 3.97100000e00],
            [1.36500000e00, -3.20300000e00, 5.34100000e00],
            [-1.46700000e00, -4.19600000e00, 3.37500000e00],
            [-1.12400000e00, -4.67500000e00, 2.03600000e00],
            [-4.06300000e00, -2.80200000e00, 3.08400000e00],
            [-4.86100000e00, -3.43000000e00, 4.24300000e00],
            [-1.08200000e00, -3.61300000e00, -1.46800000e00],
            [-8.22000000e-01, -4.40700000e00, -3.41000000e-01],
            [-1.19400000e00, -3.93200000e00, 1.00000000e00],
            [-2.00000000e-01, -5.65100000e00, -5.33000000e-01],
            [1.66000000e-01, -6.08300000e00, -1.80700000e00],
            [8.18000000e-01, -7.37200000e00, -1.98400000e00],
            [1.36400000e00, -8.45600000e00, -2.12000000e00],
            [2.17700000e00, -1.00830000e01, -2.30200000e00],
            [3.99000000e00, -9.92900000e00, -1.85100000e00],
            [2.02100000e00, -1.06610000e01, -4.07900000e00],
            [1.35100000e00, -1.13240000e01, -1.16500000e00],
            [-9.50000000e-02, -5.27400000e00, -2.91200000e00],
            [-7.30000000e-01, -4.03400000e00, -2.76200000e00],
            [-9.98000000e-01, -3.22300000e00, -3.95500000e00],
            [1.15700000e00, 1.71800000e00, 5.80000000e-02],
            [1.72700000e00, 1.71200000e00, 1.33800000e00],
            [1.05100000e00, 9.91000000e-01, 2.42400000e00],
            [2.93200000e00, 2.40400000e00, 1.53500000e00],
            [3.55000000e00, 3.07800000e00, 4.81000000e-01],
            [4.80000000e00, 3.78900000e00, 7.02000000e-01],
            [5.85500000e00, 4.37700000e00, 8.87000000e-01],
            [7.43900000e00, 5.24600000e00, 1.16100000e00],
            [8.35200000e00, 5.40900000e00, -4.69000000e-01],
            [8.48600000e00, 4.26700000e00, 2.37000000e00],
            [7.10200000e00, 6.95100000e00, 1.86300000e00],
            [2.96400000e00, 3.06800000e00, -7.85000000e-01],
            [1.75800000e00, 2.39000000e00, -1.01500000e00],
            [1.11500000e00, 2.35900000e00, -2.33400000e00],
            [-4.79200000e00, 2.36000000e00, 1.27000000e-01],
            [-5.04400000e00, 3.15900000e00, -9.99000000e-01],
            [-4.46600000e00, 2.80100000e00, -2.30300000e00],
            [-5.85200000e00, 4.29500000e00, -8.40000000e-01],
            [-6.37900000e00, 4.63500000e00, 4.05000000e-01],
            [-7.20600000e00, 5.82300000e00, 5.52000000e-01],
            [-7.89400000e00, 6.82600000e00, 6.67000000e-01],
            [-8.92200000e00, 8.32900000e00, 8.22000000e-01],
            [-7.81200000e00, 9.82600000e00, 1.02800000e00],
            [-1.00400000e01, 8.16800000e00, 2.31900000e00],
            [-9.96700000e00, 8.53300000e00, -7.21000000e-01],
            [-6.10800000e00, 3.83100000e00, 1.51200000e00],
            [-5.32100000e00, 2.67900000e00, 1.38900000e00],
            [-5.07500000e00, 1.85500000e00, 2.57800000e00],
            [-4.01900000e00, 4.00200000e00, -5.20300000e00],
            [-4.96500000e00, 2.60800000e00, -5.29500000e00],
            [-2.41000000e00, 4.70900000e00, -3.75800000e00],
            [-7.20000000e-01, 4.62100000e00, -3.72900000e00],
            [-2.38900000e00, 5.08600000e00, -6.28600000e00],
            [-6.41000000e-01, 4.99000000e00, -6.27100000e00],
            [-1.45400000e00, 6.29700000e00, -5.42200000e00],
            [1.62300000e00, 2.38600000e00, -5.39400000e00],
            [8.61000000e-01, 3.85300000e00, -5.06300000e00],
            [1.58900000e00, 3.46000000e-01, -4.51700000e00],
            [6.89000000e-01, -1.06900000e00, -4.69200000e00],
            [5.18000000e-01, -6.87000000e-01, -7.21700000e00],
            [2.18500000e00, -7.69000000e-01, -6.66000000e00],
            [1.45300000e00, 7.85000000e-01, -7.03100000e00],
            [-1.08700000e00, -1.74600000e00, -5.97900000e00],
            [-2.76300000e00, -1.74400000e00, -5.68100000e00],
            [-4.23700000e00, -8.50000000e-01, -4.36700000e00],
            [-5.02300000e00, 6.42000000e-01, -4.23400000e00],
            [-4.26800000e00, -6.43000000e-01, -6.93400000e00],
            [-5.08300000e00, 8.98000000e-01, -6.77100000e00],
            [-5.87700000e00, -5.73000000e-01, -6.23100000e00],
            [-4.40100000e00, 7.14000000e-01, 4.70600000e00],
            [-5.10900000e00, -6.55000000e-01, 3.98400000e00],
            [-2.65800000e00, 2.05400000e00, 4.04500000e00],
            [-9.96000000e-01, 2.10700000e00, 4.32500000e00],
            [-2.21700000e00, 2.86600000e00, 6.35600000e00],
            [-3.07700000e00, 1.33600000e00, 6.46400000e00],
            [-1.34900000e00, 1.39000000e00, 6.75300000e00],
            [1.47300000e00, -4.02000000e-01, 5.18600000e00],
            [5.09000000e-01, 9.52000000e-01, 5.47600000e00],
            [9.98000000e-01, -3.40500000e00, 3.21300000e00],
            [1.72700000e00, -1.93100000e00, 3.61500000e00],
            [6.63000000e-01, -3.96200000e00, 5.68500000e00],
            [2.34900000e00, -3.66900000e00, 5.29000000e00],
            [1.40600000e00, -2.43600000e00, 6.11500000e00],
            [-2.37700000e00, -4.70200000e00, 3.69100000e00],
            [-7.33000000e-01, -4.61200000e00, 4.06200000e00],
            [-4.70500000e00, -2.16100000e00, 2.47800000e00],
            [-3.78200000e00, -3.57500000e00, 2.36900000e00],
            [-4.26000000e00, -4.14000000e00, 4.81100000e00],
            [-5.73200000e00, -3.96700000e00, 3.86600000e00],
            [-5.21800000e00, -2.68100000e00, 4.94800000e00],
            [-1.56800000e00, -2.65300000e00, -1.34700000e00],
            [-1.54800000e00, -2.90400000e00, 1.04300000e00],
            [9.00000000e-03, -6.28600000e00, 3.17000000e-01],
            [4.11000000e00, -9.58900000e00, -8.23000000e-01],
            [4.50300000e00, -1.08850000e01, -1.94800000e00],
            [4.49600000e00, -9.21200000e00, -2.49700000e00],
            [9.76000000e-01, -1.07550000e01, -4.37000000e00],
            [2.49500000e00, -1.16310000e01, -4.22000000e00],
            [2.49400000e00, -9.95700000e00, -4.76300000e00],
            [1.42400000e00, -1.10110000e01, -1.25000000e-01],
            [2.94000000e-01, -1.14320000e01, -1.40400000e00],
            [1.81400000e00, -1.23060000e01, -1.25100000e00],
            [1.94000000e-01, -5.62700000e00, -3.89300000e00],
            [-5.61000000e-01, -3.61800000e00, -4.87000000e00],
            [2.26000000e-01, 1.18800000e00, -1.07000000e-01],
            [1.47000000e-01, 4.74000000e-01, 2.11400000e00],
            [3.39200000e00, 2.41600000e00, 2.51400000e00],
            [7.76400000e00, 5.97200000e00, -1.19200000e00],
            [8.55900000e00, 4.43100000e00, -9.01000000e-01],
            [9.30300000e00, 5.92400000e00, -3.39000000e-01],
            [8.69600000e00, 3.26900000e00, 1.98800000e00],
            [9.44000000e00, 4.76000000e00, 2.55500000e00],
            [7.97800000e00, 4.15500000e00, 3.32700000e00],
            [6.49200000e00, 7.54200000e00, 1.18100000e00],
            [8.02900000e00, 7.49600000e00, 2.03800000e00],
            [6.57000000e00, 6.88600000e00, 2.81100000e00],
            [3.45000000e00, 3.59400000e00, -1.59700000e00],
            [1.69000000e-01, 1.82300000e00, -2.35200000e00],
            [-4.17800000e00, 1.47300000e00, 2.90000000e-02],
            [-3.75400000e00, 1.97900000e00, -2.28200000e00],
            [-6.06700000e00, 4.92800000e00, -1.69100000e00],
            [-7.19000000e00, 9.73300000e00, 1.91800000e00],
            [-7.14700000e00, 9.94100000e00, 1.73000000e-01],
            [-8.39500000e00, 1.07400000e01, 1.12300000e00],
            [-1.06670000e01, 9.05000000e00, 2.43900000e00],
            [-9.45700000e00, 8.04800000e00, 3.23200000e00],
            [-1.06950000e01, 7.30300000e00, 2.22800000e00],
            [-9.34200000e00, 8.62600000e00, -1.60800000e00],
            [-1.05930000e01, 9.42200000e00, -6.59000000e-01],
            [-1.06220000e01, 7.67400000e00, -8.67000000e-01],
            [-6.52800000e00, 4.10900000e00, 2.47000000e00],
            [-5.44300000e00, 2.29000000e00, 3.50600000e00],
        ],
    ),
}

case_3 = {
    "elements": np.array(
        [
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "N",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "N",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "N",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "N",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
        ],
    ),
    "coordinates": np.array(
        [
            [7.17200000e00, 3.12300000e00, -3.00700000e00],
            [7.76400000e00, 1.93800000e00, -2.55800000e00],
            [8.08000000e00, 1.80500000e00, -1.20200000e00],
            [7.80100000e00, 2.83300000e00, -2.98000000e-01],
            [7.20800000e00, 4.01100000e00, -7.65000000e-01],
            [6.88500000e00, 4.16200000e00, -2.11600000e00],
            [6.25400000e00, 5.46000000e00, -2.61500000e00],
            [5.01900000e00, 5.20400000e00, -3.34300000e00],
            [8.16700000e00, 2.68000000e00, 1.17700000e00],
            [7.01700000e00, 2.92200000e00, 2.03700000e00],
            [8.08700000e00, 8.19000000e-01, -3.54500000e00],
            [7.50300000e00, -4.46000000e-01, -3.12000000e00],
            [-6.60100000e00, 3.66100000e00, -3.36700000e00],
            [-5.98700000e00, 4.82900000e00, -2.90300000e00],
            [-4.98800000e00, 5.42800000e00, -3.67700000e00],
            [-4.59400000e00, 4.86700000e00, -4.89600000e00],
            [-5.21900000e00, 3.69900000e00, -5.34300000e00],
            [-6.22000000e00, 3.08600000e00, -4.58200000e00],
            [-6.91000000e00, 1.82000000e00, -5.08400000e00],
            [-5.94400000e00, 7.77000000e-01, -5.39600000e00],
            [-3.51500000e00, 5.53500000e00, -5.74500000e00],
            [-2.29100000e00, 5.74100000e00, -4.98300000e00],
            [-6.42000000e00, 5.46200000e00, -1.58300000e00],
            [-6.34100000e00, 4.50800000e00, -4.86000000e-01],
            [4.79000000e-01, -7.49600000e00, -4.23500000e00],
            [1.24500000e00, -7.91100000e00, -3.14000000e00],
            [5.97000000e-01, -8.31900000e00, -1.97000000e00],
            [-7.98000000e-01, -8.30500000e00, -1.88200000e00],
            [-1.54800000e00, -7.88700000e00, -2.98600000e00],
            [-9.17000000e-01, -7.47500000e00, -4.16500000e00],
            [-1.74100000e00, -7.03600000e00, -5.37300000e00],
            [-2.67300000e00, -5.97400000e00, -5.02200000e00],
            [-1.50000000e00, -8.76800000e00, -6.08000000e-01],
            [-1.01700000e00, -8.04200000e00, 5.59000000e-01],
            [2.76800000e00, -7.94800000e00, -3.22900000e00],
            [3.30800000e00, -6.65600000e00, -3.62800000e00],
            [-2.50100000e00, -1.06600000e00, 7.58700000e00],
            [-2.74200000e00, 3.10000000e-01, 7.53300000e00],
            [-1.68000000e00, 1.19700000e00, 7.73300000e00],
            [-3.87000000e-01, 7.23000000e-01, 7.97300000e00],
            [-1.64000000e-01, -6.57000000e-01, 8.02400000e00],
            [-1.21400000e00, -1.55900000e00, 7.82600000e00],
            [-9.59000000e-01, -3.06200000e00, 7.90100000e00],
            [-1.43200000e00, -3.74100000e00, 6.70200000e00],
            [7.60000000e-01, 1.70400000e00, 8.20700000e00],
            [1.87300000e00, 1.44200000e00, 7.30600000e00],
            [-4.15600000e00, 8.33000000e-01, 7.28800000e00],
            [-4.19000000e00, 1.76000000e00, 6.16500000e00],
            [2.46300000e00, 4.83200000e00, -4.72300000e00],
            [1.20900000e00, 4.71100000e00, -5.31800000e00],
            [9.30000000e-02, 5.34700000e00, -4.76400000e00],
            [-1.21600000e00, 5.21000000e00, -5.42100000e00],
            [2.63000000e-01, 6.10400000e00, -3.59700000e00],
            [1.51700000e00, 6.22700000e00, -3.00400000e00],
            [2.63500000e00, 5.59500000e00, -3.56000000e00],
            [3.94800000e00, 5.75300000e00, -2.91700000e00],
            [5.14800000e00, -2.85900000e00, -4.55500000e00],
            [4.52300000e00, -4.08000000e00, -4.30900000e00],
            [4.77300000e00, -4.78900000e00, -3.12600000e00],
            [4.13900000e00, -6.08600000e00, -2.84500000e00],
            [5.66000000e00, -4.24000000e00, -2.19300000e00],
            [6.28200000e00, -3.01900000e00, -2.43700000e00],
            [6.03800000e00, -2.31300000e00, -3.62300000e00],
            [6.69000000e00, -1.02800000e00, -3.91400000e00],
            [4.75500000e00, 3.27000000e00, 3.86300000e00],
            [3.69500000e00, 3.35100000e00, 4.76400000e00],
            [3.36900000e00, 2.26300000e00, 5.58200000e00],
            [2.25200000e00, 2.38200000e00, 6.53100000e00],
            [4.12900000e00, 1.09100000e00, 5.47200000e00],
            [5.19000000e00, 1.01000000e00, 4.57300000e00],
            [5.51900000e00, 2.10000000e00, 3.75800000e00],
            [6.65200000e00, 1.98900000e00, 2.82700000e00],
            [-4.50500000e00, -3.75800000e00, -4.46800000e00],
            [-5.33400000e00, -2.65600000e00, -4.26900000e00],
            [-5.14800000e00, -1.48100000e00, -5.00700000e00],
            [-6.04500000e00, -3.37000000e-01, -4.78200000e00],
            [-4.10800000e00, -1.43700000e00, -5.94500000e00],
            [-3.28100000e00, -2.54000000e00, -6.14500000e00],
            [-3.47000000e00, -3.71600000e00, -5.41100000e00],
            [-2.58700000e00, -4.86800000e00, -5.65100000e00],
            [-4.41200000e00, 3.54600000e00, 3.85600000e00],
            [-4.57800000e00, 4.33800000e00, 2.72100000e00],
            [-5.43300000e00, 3.93500000e00, 1.68900000e00],
            [-5.59600000e00, 4.79700000e00, 5.09000000e-01],
            [-6.11400000e00, 2.71700000e00, 1.82000000e00],
            [-5.95000000e00, 1.92700000e00, 2.95500000e00],
            [-5.09800000e00, 2.33200000e00, 3.99000000e00],
            [-4.95300000e00, 1.48100000e00, 5.18100000e00],
            [-2.52700000e00, -5.92800000e00, 3.14200000e00],
            [-2.23300000e00, -5.20400000e00, 4.29500000e00],
            [-9.26000000e-01, -5.15900000e00, 4.80000000e00],
            [-5.87000000e-01, -4.41300000e00, 6.02200000e00],
            [7.90000000e-02, -5.85200000e00, 4.11600000e00],
            [-2.14000000e-01, -6.57400000e00, 2.96200000e00],
            [-1.52300000e00, -6.62500000e00, 2.46100000e00],
            [-1.86600000e00, -7.38900000e00, 1.25200000e00],
            [6.92100000e00, 3.24300000e00, -4.05100000e00],
            [8.53800000e00, 8.88000000e-01, -8.59000000e-01],
            [6.99400000e00, 4.80400000e00, -6.30000000e-02],
            [6.14600000e00, 6.16200000e00, -1.78100000e00],
            [6.96500000e00, 5.93000000e00, -3.29700000e00],
            [8.93000000e00, 3.42500000e00, 1.40500000e00],
            [8.65100000e00, 1.71100000e00, 1.33900000e00],
            [9.17200000e00, 7.05000000e-01, -3.57100000e00],
            [7.80300000e00, 1.12500000e00, -4.55700000e00],
            [-7.37300000e00, 3.20100000e00, -2.76600000e00],
            [-4.50300000e00, 6.33100000e00, -3.33400000e00],
            [-4.92600000e00, 3.25200000e00, -6.28200000e00],
            [-7.44600000e00, 2.07800000e00, -5.99900000e00],
            [-7.68500000e00, 1.51500000e00, -4.37200000e00],
            [-3.37500000e00, 4.97200000e00, -6.67400000e00],
            [-3.89700000e00, 6.51000000e00, -6.05300000e00],
            [-5.85600000e00, 6.38600000e00, -1.41400000e00],
            [-7.45900000e00, 5.77500000e00, -1.69300000e00],
            [9.82000000e-01, -7.18100000e00, -5.13800000e00],
            [1.17300000e00, -8.64200000e00, -1.11600000e00],
            [-2.62700000e00, -7.87000000e00, -2.93500000e00],
            [-2.31500000e00, -7.90000000e00, -5.71100000e00],
            [-1.07300000e00, -6.78900000e00, -6.20500000e00],
            [-1.27200000e00, -9.82700000e00, -4.73000000e-01],
            [-2.58600000e00, -8.72200000e00, -7.46000000e-01],
            [3.03600000e00, -8.68300000e00, -3.99000000e00],
            [3.18300000e00, -8.33700000e00, -2.29300000e00],
            [-3.31000000e00, -1.76600000e00, 7.43500000e00],
            [-1.87000000e00, 2.26000000e00, 7.69100000e00],
            [8.36000000e-01, -1.02000000e00, 8.21000000e00],
            [9.50000000e-02, -3.24700000e00, 8.13500000e00],
            [-1.51600000e00, -3.44800000e00, 8.75700000e00],
            [3.82000000e-01, 2.73100000e00, 8.16500000e00],
            [1.10700000e00, 1.56600000e00, 9.23200000e00],
            [-4.85000000e00, -9.00000000e-03, 7.19500000e00],
            [-4.46900000e00, 1.36800000e00, 8.18600000e00],
            [3.30800000e00, 4.33000000e00, -5.17400000e00],
            [1.12000000e00, 4.11600000e00, -6.21600000e00],
            [-1.20300000e00, 4.60800000e00, -6.32700000e00],
            [-5.82000000e-01, 6.60500000e00, -3.14500000e00],
            [1.60600000e00, 6.82300000e00, -2.10600000e00],
            [3.94200000e00, 6.38400000e00, -2.03100000e00],
            [4.93000000e00, -2.34600000e00, -5.48100000e00],
            [3.84100000e00, -4.47800000e00, -5.04800000e00],
            [4.43300000e00, -6.53300000e00, -1.89800000e00],
            [5.87800000e00, -4.75400000e00, -1.26700000e00],
            [6.96400000e00, -2.62100000e00, -1.69700000e00],
            [6.42300000e00, -5.96000000e-01, -4.87700000e00],
            [4.98400000e00, 4.12700000e00, 3.24500000e00],
            [3.13300000e00, 4.27200000e00, 4.81600000e00],
            [1.75800000e00, 3.35200000e00, 6.52300000e00],
            [3.89900000e00, 2.33000000e-01, 6.08900000e00],
            [5.75300000e00, 8.90000000e-02, 4.52100000e00],
            [7.16700000e00, 1.03100000e00, 2.85800000e00],
            [-4.67400000e00, -4.65200000e00, -3.88300000e00],
            [-6.12300000e00, -2.73000000e00, -3.53400000e00],
            [-6.81800000e00, -5.12000000e-01, -4.03700000e00],
            [-3.93800000e00, -5.42000000e-01, -6.52900000e00],
            [-2.49200000e00, -2.46600000e00, -6.88100000e00],
            [-1.83500000e00, -4.70400000e00, -6.42100000e00],
            [-3.74500000e00, 3.88400000e00, 4.63700000e00],
            [-4.03300000e00, 5.26900000e00, 2.65800000e00],
            [-5.02200000e00, 5.72000000e00, 5.44000000e-01],
            [-6.78000000e00, 2.37900000e00, 1.03800000e00],
            [-6.49600000e00, 9.96000000e-01, 3.01900000e00],
            [-5.55500000e00, 5.75000000e-01, 5.16100000e00],
            [-3.54800000e00, -5.94000000e00, 2.78800000e00],
            [-3.03000000e00, -4.67600000e00, 4.80100000e00],
            [4.60000000e-01, -4.47600000e00, 6.31000000e00],
            [1.10000000e00, -5.84000000e00, 4.47100000e00],
            [5.83000000e-01, -7.10000000e00, 2.45600000e00],
            [-2.92000000e00, -7.35600000e00, 9.84000000e-01],
        ],
    ),
}

case_4 = {
    "elements": np.array(
        [
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "N",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "N",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "N",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "N",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
        ],
    ),
    "coordinates": np.array(
        [
            [-1.66520000e01, 2.63100000e00, 1.67110000e01],
            [-1.69730000e01, 1.23200000e00, 1.61630000e01],
            [-1.64700000e01, 8.30000000e-02, 1.68110000e01],
            [-1.68200000e01, -1.19800000e00, 1.63360000e01],
            [-1.76370000e01, -1.33300000e00, 1.51920000e01],
            [-1.81380000e01, -1.82000000e-01, 1.45490000e01],
            [-1.77900000e01, 1.10300000e00, 1.50200000e01],
            [-1.82830000e01, 2.36200000e00, 1.42750000e01],
            [-1.96460000e01, 2.68000000e00, 1.46730000e01],
            [-1.90800000e01, -3.34000000e-01, 1.33450000e01],
            [-1.79630000e01, -2.73500000e00, 1.46330000e01],
            [-1.90620000e01, -3.33000000e00, 1.53800000e01],
            [-1.63240000e01, -2.44600000e00, 1.70830000e01],
            [-1.55210000e01, 2.27000000e-01, 1.80200000e01],
            [-1.62890000e01, 4.68000000e-01, 1.92340000e01],
            [-3.35580000e01, 2.27700000e00, 1.70640000e01],
            [-3.30320000e01, 9.71000000e-01, 1.64460000e01],
            [-3.33330000e01, -2.68000000e-01, 1.70520000e01],
            [-3.28120000e01, -1.46000000e00, 1.65070000e01],
            [-3.20480000e01, -1.42400000e00, 1.53210000e01],
            [-3.17310000e01, -1.81000000e-01, 1.47300000e01],
            [-3.22300000e01, 1.01600000e00, 1.52850000e01],
            [-3.19050000e01, 2.37300000e00, 1.46230000e01],
            [-3.07950000e01, 3.00000000e00, 1.53250000e01],
            [-3.08200000e01, -1.22000000e-01, 1.34940000e01],
            [-3.15930000e01, -2.73800000e00, 1.46520000e01],
            [-3.02180000e01, -3.05000000e00, 1.50180000e01],
            [-3.30590000e01, -2.79700000e00, 1.72180000e01],
            [-3.42440000e01, -3.17000000e-01, 1.82980000e01],
            [-3.34650000e01, -2.40000000e-02, 1.94920000e01],
            [-2.22660000e01, 8.28600000e00, 2.53410000e01],
            [-2.36050000e01, 7.89600000e00, 2.59840000e01],
            [-2.48230000e01, 8.25800000e00, 2.53670000e01],
            [-2.60450000e01, 7.81800000e00, 2.59190000e01],
            [-2.60570000e01, 7.09600000e00, 2.71310000e01],
            [-2.48380000e01, 6.75600000e00, 2.77570000e01],
            [-2.36110000e01, 7.15500000e00, 2.71840000e01],
            [-2.22810000e01, 6.78300000e00, 2.78730000e01],
            [-2.19170000e01, 5.41800000e00, 2.75200000e01],
            [-2.48450000e01, 5.92700000e00, 2.90530000e01],
            [-2.73980000e01, 6.69400000e00, 2.77820000e01],
            [-2.77160000e01, 5.31400000e00, 2.74480000e01],
            [-2.73630000e01, 8.10700000e00, 2.51890000e01],
            [-2.48180000e01, 9.16100000e00, 2.41150000e01],
            [-2.45820000e01, 8.37100000e00, 2.29150000e01],
            [-2.72450000e01, -8.73000000e00, 2.55440000e01],
            [-2.58940000e01, -8.23100000e00, 2.60820000e01],
            [-2.46950000e01, -8.63900000e00, 2.54580000e01],
            [-2.34570000e01, -8.16300000e00, 2.59380000e01],
            [-2.34130000e01, -7.29900000e00, 2.70540000e01],
            [-2.46160000e01, -6.85900000e00, 2.76460000e01],
            [-2.58550000e01, -7.35000000e00, 2.71840000e01],
            [-2.71650000e01, -6.93900000e00, 2.78900000e01],
            [-2.78020000e01, -5.85500000e00, 2.71590000e01],
            [-2.45780000e01, -5.82800000e00, 2.87820000e01],
            [-2.20540000e01, -6.86800000e00, 2.76450000e01],
            [-2.15070000e01, -5.74100000e00, 2.69030000e01],
            [-2.21590000e01, -8.57200000e00, 2.52240000e01],
            [-2.47410000e01, -9.60600000e00, 2.42550000e01],
            [-2.50290000e01, -8.85600000e00, 2.30420000e01],
            [-2.61650000e01, 7.95300000e00, 1.96370000e01],
            [-2.60850000e01, 7.21600000e00, 1.84570000e01],
            [-2.50830000e01, 6.25200000e00, 1.82770000e01],
            [-2.41530000e01, 6.06000000e00, 1.93070000e01],
            [-2.42340000e01, 6.79300000e00, 2.04870000e01],
            [-2.52460000e01, 7.74500000e00, 2.06720000e01],
            [-2.53730000e01, 8.50800000e00, 2.19230000e01],
            [-2.50260000e01, 5.46800000e00, 1.70870000e01],
            [-2.37630000e01, 5.07300000e00, 1.65570000e01],
            [-2.26720000e01, 5.95300000e00, 1.65660000e01],
            [-2.14270000e01, 5.55400000e00, 1.60830000e01],
            [-2.12370000e01, 4.26100000e00, 1.55820000e01],
            [-1.99040000e01, 3.84700000e00, 1.51170000e01],
            [-2.23310000e01, 3.38500000e00, 1.55580000e01],
            [-2.35740000e01, 3.78600000e00, 1.60370000e01],
            [-2.62290000e01, 4.99600000e00, 1.64840000e01],
            [-2.63340000e01, 4.86100000e00, 1.50920000e01],
            [-2.74920000e01, 4.35200000e00, 1.45070000e01],
            [-2.85800000e01, 3.96400000e00, 1.52980000e01],
            [-2.97720000e01, 3.37600000e00, 1.46660000e01],
            [-2.84860000e01, 4.12000000e00, 1.66870000e01],
            [-2.73290000e01, 4.62800000e00, 1.72700000e01],
            [-2.13380000e01, -4.47100000e00, 1.67970000e01],
            [-2.24790000e01, -4.98900000e00, 1.74020000e01],
            [-2.35880000e01, -5.37200000e00, 1.66350000e01],
            [-2.35110000e01, -5.23800000e00, 1.52420000e01],
            [-2.23670000e01, -4.72300000e00, 1.46350000e01],
            [-2.12690000e01, -4.32400000e00, 1.54050000e01],
            [-2.00890000e01, -3.74200000e00, 1.47460000e01],
            [-2.47720000e01, -5.86100000e00, 1.72600000e01],
            [-2.46760000e01, -6.67000000e00, 1.84300000e01],
            [-2.55870000e01, -6.51600000e00, 1.94840000e01],
            [-2.54660000e01, -7.27000000e00, 2.06470000e01],
            [-2.44300000e01, -8.20200000e00, 2.07940000e01],
            [-2.42510000e01, -8.96700000e00, 2.20390000e01],
            [-2.35320000e01, -8.37500000e00, 1.97350000e01],
            [-2.36540000e01, -7.62000000e00, 1.85700000e01],
            [-2.60500000e01, -5.46000000e00, 1.67710000e01],
            [-2.62530000e01, -4.16700000e00, 1.62700000e01],
            [-2.75100000e01, -3.75900000e00, 1.58350000e01],
            [-2.86040000e01, -4.63400000e00, 1.58820000e01],
            [-2.99490000e01, -4.21600000e00, 1.54580000e01],
            [-2.84000000e01, -5.93200000e00, 1.63630000e01],
            [-2.71420000e01, -6.33900000e00, 1.68020000e01],
            [-2.11900000e01, 2.74200000e00, 2.66550000e01],
            [-2.07840000e01, 1.49700000e00, 2.61840000e01],
            [-1.95100000e01, 1.32000000e00, 2.56270000e01],
            [-1.86470000e01, 2.42500000e00, 2.55800000e01],
            [-1.90540000e01, 3.67200000e00, 2.60520000e01],
            [-2.03350000e01, 3.85000000e00, 2.65850000e01],
            [-2.07660000e01, 5.18600000e00, 2.70260000e01],
            [-1.91140000e01, 5.70000000e-02, 2.50980000e01],
            [-1.95740000e01, -1.14900000e00, 2.57050000e01],
            [-1.99570000e01, -2.24600000e00, 2.49220000e01],
            [-2.04480000e01, -3.40700000e00, 2.55110000e01],
            [-2.05660000e01, -3.50900000e00, 2.69030000e01],
            [-2.11120000e01, -4.71400000e00, 2.75490000e01],
            [-2.01660000e01, -2.42300000e00, 2.76900000e01],
            [-1.96780000e01, -1.25900000e00, 2.70990000e01],
            [-1.83400000e01, -2.00000000e-03, 2.39020000e01],
            [-1.85540000e01, 9.15000000e-01, 2.28640000e01],
            [-1.78300000e01, 8.32000000e-01, 2.16790000e01],
            [-1.68660000e01, -1.69000000e-01, 2.14960000e01],
            [-1.61160000e01, -3.00000000e-01, 2.02370000e01],
            [-1.66360000e01, -1.07400000e00, 2.25380000e01],
            [-1.73650000e01, -9.93000000e-01, 2.37230000e01],
            [-2.83750000e01, 2.59800000e00, 2.66490000e01],
            [-2.87570000e01, 1.32900000e00, 2.62270000e01],
            [-3.00450000e01, 1.09500000e00, 2.57280000e01],
            [-3.09450000e01, 2.17000000e00, 2.56820000e01],
            [-3.05620000e01, 3.44200000e00, 2.61040000e01],
            [-2.92690000e01, 3.67600000e00, 2.65850000e01],
            [-2.88710000e01, 5.03400000e00, 2.69880000e01],
            [-3.04200000e01, -1.97000000e-01, 2.52530000e01],
            [-2.99030000e01, -1.36500000e00, 2.58860000e01],
            [-2.97410000e01, -1.42100000e00, 2.72780000e01],
            [-2.91920000e01, -2.54600000e00, 2.78910000e01],
            [-2.87910000e01, -3.64900000e00, 2.71290000e01],
            [-2.81760000e01, -4.81200000e00, 2.77900000e01],
            [-2.89700000e01, -3.60300000e00, 2.57400000e01],
            [-2.95170000e01, -2.47900000e00, 2.51290000e01],
            [-3.12290000e01, -3.19000000e-01, 2.40850000e01],
            [-3.21650000e01, -1.35600000e00, 2.39590000e01],
            [-3.29220000e01, -1.50100000e00, 2.27980000e01],
            [-3.27660000e01, -6.11000000e-01, 2.17290000e01],
            [-3.35460000e01, -8.04000000e-01, 2.04960000e01],
            [-3.18460000e01, 4.37000000e-01, 2.18610000e01],
            [-3.10890000e01, 5.80000000e-01, 2.30190000e01],
            [-1.64050000e01, 2.64200000e00, 1.77710000e01],
            [-1.58180000e01, 3.07100000e00, 1.61650000e01],
            [-1.75090000e01, 3.29700000e00, 1.66350000e01],
            [-1.82660000e01, 2.17500000e00, 1.32010000e01],
            [-1.75790000e01, 3.19000000e00, 1.43910000e01],
            [-1.97330000e01, 5.21000000e-01, 1.31870000e01],
            [-1.85080000e01, -4.96000000e-01, 1.24320000e01],
            [-1.97670000e01, -1.16700000e00, 1.34780000e01],
            [-1.70860000e01, -3.37500000e00, 1.47300000e01],
            [-1.81240000e01, -2.70100000e00, 1.35530000e01],
            [-1.63330000e01, -2.29600000e00, 1.81600000e01],
            [-1.69480000e01, -3.32400000e00, 1.69340000e01],
            [-1.53090000e01, -2.69500000e00, 1.67740000e01],
            [-1.48510000e01, 1.07200000e00, 1.78550000e01],
            [-1.48350000e01, -6.21000000e-01, 1.80870000e01],
            [-3.36800000e01, 2.21900000e00, 1.81440000e01],
            [-3.45210000e01, 2.54100000e00, 1.66260000e01],
            [-3.28780000e01, 3.11500000e00, 1.69250000e01],
            [-3.17500000e01, 2.26500000e00, 1.35470000e01],
            [-3.27750000e01, 3.02700000e00, 1.46860000e01],
            [-3.14160000e01, -2.50000000e-02, 1.25870000e01],
            [-3.01280000e01, 7.16000000e-01, 1.35490000e01],
            [-3.01730000e01, -9.90000000e-01, 1.33830000e01],
            [-3.23040000e01, -3.54400000e00, 1.48500000e01],
            [-3.16480000e01, -2.62400000e00, 1.35680000e01],
            [-3.22490000e01, -3.50700000e00, 1.70660000e01],
            [-3.31090000e01, -2.68400000e00, 1.82990000e01],
            [-3.39880000e01, -3.24900000e00, 1.68710000e01],
            [-3.48020000e01, -1.25500000e00, 1.83460000e01],
            [-3.50280000e01, 4.34000000e-01, 1.81980000e01],
            [-2.23310000e01, 8.47800000e00, 2.42720000e01],
            [-2.18590000e01, 9.17600000e00, 2.58200000e01],
            [-2.15370000e01, 7.48300000e00, 2.54210000e01],
            [-2.24000000e01, 6.84600000e00, 2.89550000e01],
            [-2.15020000e01, 7.52000000e00, 2.76640000e01],
            [-2.39850000e01, 5.26600000e00, 2.91350000e01],
            [-2.48550000e01, 6.58500000e00, 2.99210000e01],
            [-2.56970000e01, 5.25500000e00, 2.91250000e01],
            [-2.81880000e01, 7.40800000e00, 2.75370000e01],
            [-2.73110000e01, 6.78100000e00, 2.88650000e01],
            [-2.80920000e01, 7.31100000e00, 2.53260000e01],
            [-2.77980000e01, 9.04300000e00, 2.55390000e01],
            [-2.72380000e01, 8.16400000e00, 2.41100000e01],
            [-2.57190000e01, 9.77800000e00, 2.40770000e01],
            [-2.40200000e01, 9.89800000e00, 2.42100000e01],
            [-2.75220000e01, -9.66700000e00, 2.60270000e01],
            [-2.80540000e01, -8.01800000e00, 2.56950000e01],
            [-2.72390000e01, -8.89100000e00, 2.44680000e01],
            [-2.69960000e01, -6.72800000e00, 2.89490000e01],
            [-2.78440000e01, -7.79300000e00, 2.79120000e01],
            [-2.37260000e01, -5.15700000e00, 2.87070000e01],
            [-2.45450000e01, -6.32700000e00, 2.97500000e01],
            [-2.54390000e01, -5.16300000e00, 2.87610000e01],
            [-2.21340000e01, -6.70000000e00, 2.87230000e01],
            [-2.13550000e01, -7.70200000e00, 2.75790000e01],
            [-2.22880000e01, -8.59400000e00, 2.41440000e01],
            [-2.18370000e01, -9.55800000e00, 2.55570000e01],
            [-2.13360000e01, -7.87700000e00, 2.53770000e01],
            [-2.38360000e01, -1.02160000e01, 2.41980000e01],
            [-2.55300000e01, -1.03430000e01, 2.44090000e01],
            [-2.69580000e01, 8.68000000e00, 1.97390000e01],
            [-2.68110000e01, 7.39600000e00, 1.76770000e01],
            [-2.33760000e01, 5.31500000e00, 1.92130000e01],
            [-2.35120000e01, 6.60400000e00, 2.12690000e01],
            [-2.62040000e01, 9.20900000e00, 2.19460000e01],
            [-2.27870000e01, 6.95600000e00, 1.69530000e01],
            [-2.06090000e01, 6.26000000e00, 1.61180000e01],
            [-1.91390000e01, 4.61700000e00, 1.51870000e01],
            [-2.22160000e01, 2.37700000e00, 1.51840000e01],
            [-2.43870000e01, 3.07300000e00, 1.60280000e01],
            [-2.55090000e01, 5.14500000e00, 1.44560000e01],
            [-2.75260000e01, 4.25000000e00, 1.34310000e01],
            [-2.97150000e01, 3.27600000e00, 1.35840000e01],
            [-2.93050000e01, 3.82300000e00, 1.73280000e01],
            [-2.72840000e01, 4.70100000e00, 1.83470000e01],
            [-2.05100000e01, -4.16500000e00, 1.74210000e01],
            [-2.25060000e01, -5.06100000e00, 1.84800000e01],
            [-2.43460000e01, -5.53300000e00, 1.46220000e01],
            [-2.23530000e01, -4.62700000e00, 1.35580000e01],
            [-2.01570000e01, -3.68000000e00, 1.36620000e01],
            [-2.63790000e01, -5.78400000e00, 1.94240000e01],
            [-2.61730000e01, -7.10600000e00, 2.14500000e01],
            [-2.33940000e01, -9.63700000e00, 2.20470000e01],
            [-2.27210000e01, -9.08600000e00, 1.98080000e01],
            [-2.29410000e01, -7.77200000e00, 1.77720000e01],
            [-2.54400000e01, -3.45500000e00, 1.62450000e01],
            [-2.76340000e01, -2.74700000e00, 1.54740000e01],
            [-3.07140000e01, -4.98400000e00, 1.55520000e01],
            [-2.92170000e01, -6.63800000e00, 1.64130000e01],
            [-2.70170000e01, -7.34600000e00, 1.71720000e01],
            [-2.21890000e01, 2.84600000e00, 2.70550000e01],
            [-2.14840000e01, 6.76000000e-01, 2.62250000e01],
            [-1.76540000e01, 2.32100000e00, 2.51670000e01],
            [-1.83630000e01, 4.50100000e00, 2.59820000e01],
            [-2.00270000e01, 5.97400000e00, 2.68920000e01],
            [-1.99070000e01, -2.19400000e00, 2.38430000e01],
            [-2.07530000e01, -4.22600000e00, 2.48740000e01],
            [-2.11590000e01, -4.66600000e00, 2.86340000e01],
            [-2.02390000e01, -2.46300000e00, 2.87670000e01],
            [-1.93810000e01, -4.35000000e-01, 2.77320000e01],
            [-1.93090000e01, 1.68200000e00, 2.29570000e01],
            [-1.80370000e01, 1.54300000e00, 2.08910000e01],
            [-1.53980000e01, -1.11700000e00, 2.02180000e01],
            [-1.59010000e01, -1.86000000e00, 2.24370000e01],
            [-1.71710000e01, -1.71000000e00, 2.45080000e01],
            [-2.73660000e01, 2.74500000e00, 2.70100000e01],
            [-2.80290000e01, 5.32000000e-01, 2.62630000e01],
            [-3.19490000e01, 2.02200000e00, 2.53120000e01],
            [-3.12830000e01, 4.24500000e00, 2.60420000e01],
            [-2.96390000e01, 5.79400000e00, 2.68610000e01],
            [-3.00380000e01, -5.84000000e-01, 2.78930000e01],
            [-2.90740000e01, -2.54400000e00, 2.89650000e01],
            [-2.80570000e01, -4.71800000e00, 2.88670000e01],
            [-2.86650000e01, -4.43600000e00, 2.51200000e01],
            [-2.96090000e01, -2.47000000e00, 2.40520000e01],
            [-3.23040000e01, -2.06100000e00, 2.47660000e01],
            [-3.36240000e01, -2.32000000e00, 2.27380000e01],
            [-3.42020000e01, -1.67200000e00, 2.04990000e01],
            [-3.16960000e01, 1.13900000e00, 2.10510000e01],
            [-3.03670000e01, 1.38300000e00, 2.30690000e01],
        ],
    ),
}

case_5 = {
    "elements": np.array(
        [
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "N",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "C",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
            "H",
        ],
    ),
    "coordinates": np.array(
        [
            [-1.30540000e01, 3.02700000e00, 1.10240000e01],
            [-1.43300000e01, 3.56200000e00, 1.15230000e01],
            [-1.25400000e01, 1.68100000e00, 1.16090000e01],
            [-1.16880000e01, 1.68100000e00, 1.27340000e01],
            [-1.12450000e01, 4.59000000e-01, 1.32820000e01],
            [-1.16620000e01, -7.64000000e-01, 1.27130000e01],
            [-1.25280000e01, -7.66000000e-01, 1.15960000e01],
            [-1.29650000e01, 4.59000000e-01, 1.10440000e01],
            [-1.39360000e01, 4.69000000e-01, 9.84800000e00],
            [-1.32130000e01, 4.49000000e-01, 8.49000000e00],
            [-1.30160000e01, -2.10600000e00, 1.10010000e01],
            [-1.41260000e01, -2.62400000e00, 1.17900000e01],
            [-1.12020000e01, -2.09600000e00, 1.33390000e01],
            [-9.88200000e00, -2.61300000e00, 1.27400000e01],
            [-1.03420000e01, 4.62000000e-01, 1.45490000e01],
            [-1.09920000e01, 4.75000000e-01, 1.58680000e01],
            [-1.12820000e01, 3.01400000e00, 1.33930000e01],
            [-9.98500000e00, 3.60100000e00, 1.28090000e01],
            [-3.68840000e01, 2.29000000e00, 1.08850000e01],
            [-3.56300000e01, 2.87100000e00, 1.13840000e01],
            [-3.73870000e01, 9.63000000e-01, 1.15190000e01],
            [-3.82320000e01, 9.97000000e-01, 1.26490000e01],
            [-3.86670000e01, -2.09000000e-01, 1.32420000e01],
            [-3.82380000e01, -1.44700000e00, 1.27180000e01],
            [-3.73930000e01, -1.48100000e00, 1.15880000e01],
            [-3.69680000e01, -2.76000000e-01, 1.09880000e01],
            [-3.60130000e01, -3.12000000e-01, 9.77900000e00],
            [-3.67540000e01, -3.46000000e-01, 8.43100000e00],
            [-3.68940000e01, -2.84400000e00, 1.10300000e01],
            [-3.56300000e01, -3.38900000e00, 1.15440000e01],
            [-3.86560000e01, -2.76100000e00, 1.34070000e01],
            [-3.99600000e01, -3.34900000e00, 1.28380000e01],
            [-3.95860000e01, -1.71000000e-01, 1.44960000e01],
            [-3.89580000e01, -1.45000000e-01, 1.58240000e01],
            [-3.86440000e01, 2.34900000e00, 1.32630000e01],
            [-3.99480000e01, 2.90700000e00, 1.26650000e01],
            [-2.27450000e01, 1.21710000e01, 3.14780000e01],
            [-2.20930000e01, 1.09420000e01, 3.10040000e01],
            [-2.40980000e01, 1.25850000e01, 3.08300000e01],
            [-2.41030000e01, 1.33740000e01, 2.96600000e01],
            [-2.53270000e01, 1.37240000e01, 2.90510000e01],
            [-2.65450000e01, 1.32660000e01, 2.95980000e01],
            [-2.65420000e01, 1.24670000e01, 3.07640000e01],
            [-2.53160000e01, 1.21310000e01, 3.13820000e01],
            [-2.53010000e01, 1.12370000e01, 3.26380000e01],
            [-2.53540000e01, 1.20440000e01, 3.39470000e01],
            [-2.78710000e01, 1.19440000e01, 3.13520000e01],
            [-2.81080000e01, 1.05730000e01, 3.09180000e01],
            [-2.78730000e01, 1.36130000e01, 2.88990000e01],
            [-2.85120000e01, 1.49070000e01, 2.94340000e01],
            [-2.53310000e01, 1.45730000e01, 2.77480000e01],
            [-2.53110000e01, 1.38720000e01, 2.64570000e01],
            [-2.27710000e01, 1.38160000e01, 2.90220000e01],
            [-2.22770000e01, 1.51760000e01, 2.95440000e01],
            [-2.19290000e01, -1.14230000e01, 3.16530000e01],
            [-2.13510000e01, -1.01620000e01, 3.11670000e01],
            [-2.32450000e01, -1.19320000e01, 3.09960000e01],
            [-2.31840000e01, -1.27360000e01, 2.98380000e01],
            [-2.43760000e01, -1.31690000e01, 2.92180000e01],
            [-2.56280000e01, -1.27830000e01, 2.97450000e01],
            [-2.56900000e01, -1.19710000e01, 3.09000000e01],
            [-2.44960000e01, -1.15490000e01, 3.15270000e01],
            [-2.45540000e01, -1.06380000e01, 3.27690000e01],
            [-2.45700000e01, -1.14270000e01, 3.40900000e01],
            [-2.70570000e01, -1.15320000e01, 3.14690000e01],
            [-2.73810000e01, -1.01830000e01, 3.10200000e01],
            [-2.69220000e01, -1.32230000e01, 2.90350000e01],
            [-2.74850000e01, -1.45470000e01, 2.95800000e01],
            [-2.43100000e01, -1.40410000e01, 2.79320000e01],
            [-2.43280000e01, -1.33660000e01, 2.66270000e01],
            [-2.18190000e01, -1.31020000e01, 2.92230000e01],
            [-2.12470000e01, -1.44210000e01, 2.97730000e01],
            [-3.31380000e01, 4.06700000e00, 1.23830000e01],
            [-3.19440000e01, 4.55300000e00, 1.29110000e01],
            [-3.12540000e01, 3.83500000e00, 1.38920000e01],
            [-3.17850000e01, 2.61900000e00, 1.43340000e01],
            [-3.29800000e01, 2.13300000e00, 1.38100000e01],
            [-3.36720000e01, 2.84900000e00, 1.28270000e01],
            [-3.49300000e01, 2.30700000e00, 1.22950000e01],
            [-2.99780000e01, 4.35500000e00, 1.44610000e01],
            [-2.88790000e01, 3.50700000e00, 1.46360000e01],
            [-2.76920000e01, 3.98800000e00, 1.51820000e01],
            [-2.75770000e01, 5.32700000e00, 1.55700000e01],
            [-2.86730000e01, 6.17600000e00, 1.53890000e01],
            [-2.98590000e01, 5.69600000e00, 1.48390000e01],
            [-2.63130000e01, 5.83200000e00, 1.61770000e01],
            [-2.63420000e01, 6.65100000e00, 1.73120000e01],
            [-2.51670000e01, 7.11600000e00, 1.79130000e01],
            [-2.39420000e01, 6.74800000e00, 1.73460000e01],
            [-2.38710000e01, 5.93100000e00, 1.62140000e01],
            [-2.50680000e01, 5.48600000e00, 1.56400000e01],
            [-2.25540000e01, 5.52800000e00, 1.56470000e01],
            [-2.15180000e01, 5.11300000e00, 1.64900000e01],
            [-2.02900000e01, 4.72200000e00, 1.59660000e01],
            [-2.00660000e01, 4.73700000e00, 1.45860000e01],
            [-2.10990000e01, 5.16000000e00, 1.37420000e01],
            [-2.23300000e01, 5.54900000e00, 1.42660000e01],
            [-1.87560000e01, 4.29900000e00, 1.40280000e01],
            [-1.81250000e01, 5.03200000e00, 1.30170000e01],
            [-1.69010000e01, 4.61700000e00, 1.24980000e01],
            [-1.62800000e01, 3.45600000e00, 1.29760000e01],
            [-1.49950000e01, 2.97800000e00, 1.24470000e01],
            [-1.69120000e01, 2.72400000e00, 1.39880000e01],
            [-1.81340000e01, 3.14200000e00, 1.45070000e01],
            [-2.52140000e01, 7.96100000e00, 1.91390000e01],
            [-2.43880000e01, 9.08400000e00, 1.92650000e01],
            [-2.44120000e01, 9.85500000e00, 2.04250000e01],
            [-2.52590000e01, 9.52000000e00, 2.14860000e01],
            [-2.60940000e01, 8.40500000e00, 2.13540000e01],
            [-2.60720000e01, 7.63600000e00, 2.01940000e01],
            [-2.52650000e01, 1.03260000e01, 2.27390000e01],
            [-2.52670000e01, 1.17240000e01, 2.26920000e01],
            [-2.52730000e01, 1.24730000e01, 2.38670000e01],
            [-2.52740000e01, 1.18400000e01, 2.51170000e01],
            [-2.52850000e01, 1.25940000e01, 2.63780000e01],
            [-2.52680000e01, 1.04410000e01, 2.51610000e01],
            [-2.52650000e01, 9.69500000e00, 2.39860000e01],
            [-3.29410000e01, -2.47900000e00, 1.38650000e01],
            [-3.17190000e01, -2.91000000e00, 1.43750000e01],
            [-3.11750000e01, -4.13900000e00, 1.39860000e01],
            [-3.18860000e01, -4.93100000e00, 1.30800000e01],
            [-3.31060000e01, -4.50000000e00, 1.25640000e01],
            [-3.36480000e01, -3.26600000e00, 1.29480000e01],
            [-3.49240000e01, -2.77000000e00, 1.24130000e01],
            [-2.98600000e01, -4.58600000e00, 1.45230000e01],
            [-2.96810000e01, -5.89500000e00, 1.49840000e01],
            [-2.84500000e01, -6.30500000e00, 1.54940000e01],
            [-2.73710000e01, -5.41700000e00, 1.55480000e01],
            [-2.75490000e01, -4.11200000e00, 1.50800000e01],
            [-2.87790000e01, -3.70100000e00, 1.45760000e01],
            [-2.60550000e01, -5.84400000e00, 1.61000000e01],
            [-2.48630000e01, -5.50800000e00, 1.54480000e01],
            [-2.36170000e01, -5.86100000e00, 1.59730000e01],
            [-2.35750000e01, -6.57800000e00, 1.71730000e01],
            [-2.47460000e01, -6.94800000e00, 1.78460000e01],
            [-2.59760000e01, -6.57200000e00, 1.72930000e01],
            [-2.46830000e01, -7.71500000e00, 1.91220000e01],
            [-2.55020000e01, -7.37000000e00, 2.02020000e01],
            [-2.54420000e01, -8.08500000e00, 2.13960000e01],
            [-2.45610000e01, -9.16300000e00, 2.15380000e01],
            [-2.37430000e01, -9.50900000e00, 2.04580000e01],
            [-2.38020000e01, -8.79300000e00, 1.92650000e01],
            [-2.44980000e01, -9.92700000e00, 2.28170000e01],
            [-2.44430000e01, -1.13250000e01, 2.28120000e01],
            [-2.43950000e01, -1.20380000e01, 2.40070000e01],
            [-2.43980000e01, -1.13700000e01, 2.52390000e01],
            [-2.43620000e01, -1.20910000e01, 2.65200000e01],
            [-2.44470000e01, -9.97100000e00, 2.52420000e01],
            [-2.44960000e01, -9.26000000e00, 2.40460000e01],
            [-2.23650000e01, -5.46500000e00, 1.52770000e01],
            [-2.21830000e01, -5.75200000e00, 1.39220000e01],
            [-2.10160000e01, -5.36400000e00, 1.32670000e01],
            [-2.00100000e01, -4.66600000e00, 1.39480000e01],
            [-2.01980000e01, -4.38400000e00, 1.53070000e01],
            [-2.13570000e01, -4.78500000e00, 1.59650000e01],
            [-1.87710000e01, -4.22000000e00, 1.32400000e01],
            [-1.88230000e01, -3.77800000e00, 1.19130000e01],
            [-1.76730000e01, -3.34300000e00, 1.12580000e01],
            [-1.64400000e01, -3.32300000e00, 1.19200000e01],
            [-1.52490000e01, -2.82000000e00, 1.12190000e01],
            [-1.63850000e01, -3.77100000e00, 1.32470000e01],
            [-1.75340000e01, -4.22100000e00, 1.38940000e01],
            [-2.01900000e01, -7.63900000e00, 3.01780000e01],
            [-1.97170000e01, -6.44500000e00, 2.96370000e01],
            [-2.04190000e01, -5.80000000e00, 2.86140000e01],
            [-2.16070000e01, -6.37200000e00, 2.81480000e01],
            [-2.20830000e01, -7.56200000e00, 2.86890000e01],
            [-2.13800000e01, -8.21200000e00, 2.97100000e01],
            [-2.19120000e01, -9.47000000e00, 3.02490000e01],
            [-1.99230000e01, -4.52200000e00, 2.80320000e01],
            [-1.99250000e01, -4.32700000e00, 2.66470000e01],
            [-1.94990000e01, -3.12000000e00, 2.61010000e01],
            [-1.90640000e01, -2.07900000e00, 2.69270000e01],
            [-1.90440000e01, -2.28000000e00, 2.83110000e01],
            [-1.94660000e01, -3.49000000e00, 2.88570000e01],
            [-1.86590000e01, -7.71000000e-01, 2.63400000e01],
            [-1.91110000e01, 4.29000000e-01, 2.68960000e01],
            [-1.87880000e01, 1.66900000e00, 2.63340000e01],
            [-1.79760000e01, 1.68900000e00, 2.51950000e01],
            [-1.75020000e01, 5.09000000e-01, 2.46100000e01],
            [-1.78500000e01, -7.11000000e-01, 2.52000000e01],
            [-1.66790000e01, 5.43000000e-01, 2.33690000e01],
            [-1.55510000e01, -2.74000000e-01, 2.32340000e01],
            [-1.48080000e01, -2.70000000e-01, 2.20550000e01],
            [-1.51790000e01, 5.49000000e-01, 2.09840000e01],
            [-1.62950000e01, 1.37900000e00, 2.11260000e01],
            [-1.70360000e01, 1.37700000e00, 2.23050000e01],
            [-1.44110000e01, 5.27000000e-01, 1.97070000e01],
            [-1.50830000e01, 4.80000000e-01, 1.84810000e01],
            [-1.43750000e01, 4.52000000e-01, 1.72830000e01],
            [-1.29760000e01, 4.72000000e-01, 1.72810000e01],
            [-1.22660000e01, 4.48000000e-01, 1.59950000e01],
            [-1.23020000e01, 5.19000000e-01, 1.85090000e01],
            [-1.30130000e01, 5.44000000e-01, 1.97070000e01],
            [-1.93250000e01, 2.93000000e00, 2.69170000e01],
            [-2.06650000e01, 3.00900000e00, 2.73110000e01],
            [-2.11800000e01, 4.18700000e00, 2.78420000e01],
            [-2.03690000e01, 5.31600000e00, 2.79930000e01],
            [-1.90270000e01, 5.23600000e00, 2.76070000e01],
            [-1.85110000e01, 4.05700000e00, 2.70730000e01],
            [-2.09340000e01, 6.57900000e00, 2.85460000e01],
            [-2.02360000e01, 7.31800000e00, 2.95070000e01],
            [-2.07750000e01, 8.49200000e00, 3.00280000e01],
            [-2.20260000e01, 8.95600000e00, 2.95970000e01],
            [-2.26300000e01, 1.01880000e01, 3.01190000e01],
            [-2.27190000e01, 8.21700000e00, 2.86320000e01],
            [-2.21790000e01, 7.04400000e00, 2.81140000e01],
            [-2.82320000e01, -7.50300000e00, 3.01950000e01],
            [-2.86650000e01, -6.27800000e00, 2.96930000e01],
            [-2.97490000e01, -6.20700000e00, 2.88100000e01],
            [-3.03970000e01, -7.39700000e00, 2.84560000e01],
            [-2.99770000e01, -8.62100000e00, 2.89700000e01],
            [-2.88840000e01, -8.69200000e00, 2.98410000e01],
            [-2.84510000e01, -1.00020000e01, 3.03490000e01],
            [-3.02020000e01, -4.89600000e00, 2.82510000e01],
            [-3.15610000e01, -4.64900000e00, 2.80180000e01],
            [-3.19820000e01, -3.44400000e00, 2.74630000e01],
            [-3.10560000e01, -2.44800000e00, 2.71440000e01],
            [-2.97010000e01, -2.67700000e00, 2.73970000e01],
            [-2.92790000e01, -3.89000000e00, 2.79360000e01],
            [-3.15080000e01, -1.17500000e00, 2.65250000e01],
            [-3.11550000e01, 6.30000000e-02, 2.70740000e01],
            [-3.15990000e01, 1.26200000e00, 2.65060000e01],
            [-3.23860000e01, 1.20500000e00, 2.53520000e01],
            [-3.27300000e01, -1.40000000e-02, 2.47580000e01],
            [-3.22960000e01, -1.19400000e00, 2.53700000e01],
            [-3.35090000e01, -5.40000000e-02, 2.34880000e01],
            [-3.46120000e01, 7.83000000e-01, 2.32920000e01],
            [-3.53140000e01, 7.61000000e-01, 2.20880000e01],
            [-3.49250000e01, -9.60000000e-02, 2.10520000e01],
            [-3.38300000e01, -9.41000000e-01, 2.12540000e01],
            [-3.31310000e01, -9.21000000e-01, 2.24570000e01],
            [-3.56520000e01, -1.03000000e-01, 1.97520000e01],
            [-3.49440000e01, -1.25000000e-01, 1.85460000e01],
            [-3.56150000e01, -1.36000000e-01, 1.73260000e01],
            [-3.70140000e01, -1.27000000e-01, 1.72830000e01],
            [-3.76890000e01, -1.47000000e-01, 1.59780000e01],
            [-3.77240000e01, -1.01000000e-01, 1.84910000e01],
            [-3.70500000e01, -8.80000000e-02, 1.97100000e01],
            [-3.12400000e01, 2.57300000e00, 2.71060000e01],
            [-3.22340000e01, 3.50200000e00, 2.74190000e01],
            [-3.19000000e01, 4.73900000e00, 2.79640000e01],
            [-3.05630000e01, 5.08500000e00, 2.81920000e01],
            [-2.95700000e01, 4.14700000e00, 2.78800000e01],
            [-2.99050000e01, 2.90200000e00, 2.73520000e01],
            [-3.02030000e01, 6.42800000e00, 2.87440000e01],
            [-3.09320000e01, 7.56800000e00, 2.83830000e01],
            [-3.05980000e01, 8.82200000e00, 2.88900000e01],
            [-2.95110000e01, 8.97300000e00, 2.97580000e01],
            [-2.91660000e01, 1.03140000e01, 3.02540000e01],
            [-2.87790000e01, 7.83400000e00, 3.01190000e01],
            [-2.91260000e01, 6.57900000e00, 2.96250000e01],
            [-1.22990000e01, 3.80200000e00, 1.11390000e01],
            [-1.31260000e01, 2.94900000e00, 9.94100000e00],
            [-1.46090000e01, 1.32400000e00, 9.89600000e00],
            [-1.46380000e01, -3.59000000e-01, 9.91400000e00],
            [-1.25880000e01, -4.36000000e-01, 8.37700000e00],
            [-1.39300000e01, 4.55000000e-01, 7.66800000e00],
            [-1.25680000e01, 1.31900000e00, 8.36700000e00],
            [-1.22080000e01, -2.83600000e00, 1.10190000e01],
            [-1.32320000e01, -2.01900000e00, 9.93400000e00],
            [-1.19710000e01, -2.86100000e00, 1.32480000e01],
            [-1.11130000e01, -2.00500000e00, 1.44210000e01],
            [-9.97100000e00, -2.79500000e00, 1.16690000e01],
            [-9.06900000e00, -1.90200000e00, 1.28830000e01],
            [-9.58500000e00, -3.55100000e00, 1.32100000e01],
            [-9.65700000e00, 1.30700000e00, 1.45080000e01],
            [-9.65300000e00, -3.81000000e-01, 1.45240000e01],
            [-1.11850000e01, 2.90200000e00, 1.44720000e01],
            [-1.20890000e01, 3.74300000e00, 1.33190000e01],
            [-9.14100000e00, 2.92500000e00, 1.29420000e01],
            [-1.00750000e01, 3.80000000e00, 1.17410000e01],
            [-9.73200000e00, 4.54200000e00, 1.32970000e01],
            [-3.76560000e01, 3.05300000e00, 1.09610000e01],
            [-3.67930000e01, 2.17500000e00, 9.80600000e00],
            [-3.53230000e01, 5.31000000e-01, 9.80300000e00],
            [-3.53300000e01, -1.15800000e00, 9.84700000e00],
            [-3.73940000e01, -1.22400000e00, 8.34400000e00],
            [-3.60480000e01, -3.71000000e-01, 7.60100000e00],
            [-3.73880000e01, 5.31000000e-01, 8.29700000e00],
            [-3.76610000e01, -3.60500000e00, 1.11610000e01],
            [-3.68190000e01, -2.79100000e00, 9.94500000e00],
            [-3.87520000e01, -2.62100000e00, 1.44840000e01],
            [-3.78560000e01, -3.49900000e00, 1.33490000e01],
            [-3.98720000e01, -3.57400000e00, 1.17760000e01],
            [-4.02220000e01, -4.27500000e00, 1.33490000e01],
            [-4.07980000e01, -2.66200000e00, 1.29550000e01],
            [-4.02760000e01, -1.01200000e00, 1.44700000e01],
            [-4.02650000e01, 6.76000000e-01, 1.44320000e01],
            [-3.78440000e01, 3.08100000e00, 1.31590000e01],
            [-3.87360000e01, 2.27100000e00, 1.43460000e01],
            [-3.98630000e01, 3.07200000e00, 1.15910000e01],
            [-4.07880000e01, 2.23100000e00, 1.28230000e01],
            [-4.02060000e01, 3.86200000e00, 1.31240000e01],
            [-2.28510000e01, 1.20990000e01, 3.25580000e01],
            [-2.20300000e01, 1.29850000e01, 3.13790000e01],
            [-2.44300000e01, 1.05830000e01, 3.26360000e01],
            [-2.61160000e01, 1.05160000e01, 3.26170000e01],
            [-2.45080000e01, 1.27240000e01, 3.40370000e01],
            [-2.62620000e01, 1.26440000e01, 3.40140000e01],
            [-2.53360000e01, 1.13800000e01, 3.48120000e01],
            [-2.78260000e01, 1.19570000e01, 3.24400000e01],
            [-2.86980000e01, 1.26250000e01, 3.11430000e01],
            [-2.85760000e01, 1.27870000e01, 2.89730000e01],
            [-2.77410000e01, 1.36860000e01, 2.78200000e01],
            [-2.78580000e01, 1.57670000e01, 2.92880000e01],
            [-2.94500000e01, 1.51180000e01, 2.89210000e01],
            [-2.87270000e01, 1.48420000e01, 3.05000000e01],
            [-2.61880000e01, 1.52440000e01, 2.77520000e01],
            [-2.45010000e01, 1.52770000e01, 2.77560000e01],
            [-2.20000000e01, 1.30600000e01, 2.91690000e01],
            [-2.28530000e01, 1.38390000e01, 2.79350000e01],
            [-2.21080000e01, 1.51580000e01, 3.06200000e01],
            [-2.13360000e01, 1.54540000e01, 2.90690000e01],
            [-2.29930000e01, 1.59720000e01, 2.93420000e01],
            [-2.11620000e01, -1.21910000e01, 3.15780000e01],
            [-2.20540000e01, -1.13400000e01, 3.27310000e01],
            [-2.37270000e01, -9.92800000e00, 3.27660000e01],
            [-2.54140000e01, -9.97200000e00, 3.27290000e01],
            [-2.36820000e01, -1.20500000e01, 3.42000000e01],
            [-2.54370000e01, -1.20840000e01, 3.41560000e01],
            [-2.46040000e01, -1.07510000e01, 3.49450000e01],
            [-2.70220000e01, -1.15310000e01, 3.25570000e01],
            [-2.78350000e01, -1.22680000e01, 3.12590000e01],
            [-2.67710000e01, -1.33020000e01, 2.79590000e01],
            [-2.76760000e01, -1.24420000e01, 2.90900000e01],
            [-2.67760000e01, -1.53660000e01, 2.94560000e01],
            [-2.77200000e01, -1.44820000e01, 3.06420000e01],
            [-2.84000000e01, -1.48250000e01, 2.90560000e01],
            [-2.34360000e01, -1.46880000e01, 2.79590000e01],
            [-2.51210000e01, -1.47670000e01, 2.79430000e01],
            [-2.10990000e01, -1.22980000e01, 2.93680000e01],
            [-2.18850000e01, -1.31470000e01, 2.81360000e01],
            [-2.02850000e01, -1.46460000e01, 2.93140000e01],
            [-2.10940000e01, -1.43760000e01, 3.08510000e01],
            [-2.19100000e01, -1.52630000e01, 2.95760000e01],
            [-3.36480000e01, 4.64200000e00, 1.16230000e01],
            [-3.15520000e01, 5.49200000e00, 1.25470000e01],
            [-3.12740000e01, 2.05200000e00, 1.50990000e01],
            [-3.33600000e01, 1.19100000e00, 1.41810000e01],
            [-3.52250000e01, 1.36400000e00, 1.27460000e01],
            [-2.89420000e01, 2.46900000e00, 1.43440000e01],
            [-2.68620000e01, 3.31000000e00, 1.53160000e01],
            [-2.86080000e01, 7.21600000e00, 1.56740000e01],
            [-3.06950000e01, 6.37000000e00, 1.47180000e01],
            [-2.72960000e01, 6.92300000e00, 1.77420000e01],
            [-2.30270000e01, 7.09500000e00, 1.78030000e01],
            [-2.50290000e01, 4.85000000e00, 1.47670000e01],
            [-2.16670000e01, 5.08300000e00, 1.75600000e01],
            [-1.95060000e01, 4.40800000e00, 1.66400000e01],
            [-2.09530000e01, 5.17600000e00, 1.26720000e01],
            [-2.31110000e01, 5.87100000e00, 1.35940000e01],
            [-1.85800000e01, 5.93500000e00, 1.26350000e01],
            [-1.64350000e01, 5.20400000e00, 1.17180000e01],
            [-1.46460000e01, 2.06300000e00, 1.29180000e01],
            [-1.64670000e01, 1.82000000e00, 1.43800000e01],
            [-1.86070000e01, 2.55300000e00, 1.52800000e01],
            [-2.37210000e01, 9.36100000e00, 1.84620000e01],
            [-2.37550000e01, 1.07090000e01, 2.05030000e01],
            [-2.67640000e01, 8.13000000e00, 2.21550000e01],
            [-2.67160000e01, 6.77100000e00, 2.01230000e01],
            [-2.52740000e01, 1.22370000e01, 2.17410000e01],
            [-2.52780000e01, 1.35530000e01, 2.38020000e01],
            [-2.52710000e01, 1.19630000e01, 2.72620000e01],
            [-2.52680000e01, 9.91600000e00, 2.61060000e01],
            [-2.52540000e01, 8.61600000e00, 2.40480000e01],
            [-3.33260000e01, -1.52300000e00, 1.41880000e01],
            [-3.11920000e01, -2.28600000e00, 1.50820000e01],
            [-3.14850000e01, -5.88200000e00, 1.27580000e01],
            [-3.36290000e01, -5.12900000e00, 1.18560000e01],
            [-3.52240000e01, -1.80900000e00, 1.28210000e01],
            [-3.05010000e01, -6.59700000e00, 1.49570000e01],
            [-2.83360000e01, -7.32100000e00, 1.58430000e01],
            [-2.67330000e01, -3.40500000e00, 1.51160000e01],
            [-2.88890000e01, -2.68700000e00, 1.42170000e01],
            [-2.49040000e01, -4.94900000e00, 1.45250000e01],
            [-2.26160000e01, -6.85000000e00, 1.75880000e01],
            [-2.68890000e01, -6.84200000e00, 1.78050000e01],
            [-2.61870000e01, -6.53900000e00, 2.01210000e01],
            [-2.60900000e01, -7.80200000e00, 2.22120000e01],
            [-2.30500000e01, -1.03330000e01, 2.05430000e01],
            [-2.31630000e01, -9.08400000e00, 1.84440000e01],
            [-2.44510000e01, -1.18660000e01, 2.18770000e01],
            [-2.43590000e01, -1.31190000e01, 2.39720000e01],
            [-2.43680000e01, -1.14380000e01, 2.73890000e01],
            [-2.44500000e01, -9.41900000e00, 2.61720000e01],
            [-2.45290000e01, -8.18000000e00, 2.40760000e01],
            [-2.29460000e01, -6.28500000e00, 1.33740000e01],
            [-2.08980000e01, -5.61100000e00, 1.22230000e01],
            [-1.94490000e01, -3.83700000e00, 1.58600000e01],
            [-2.14820000e01, -4.54600000e00, 1.70120000e01],
            [-1.97640000e01, -3.75500000e00, 1.13830000e01],
            [-1.77580000e01, -3.00300000e00, 1.02360000e01],
            [-1.54010000e01, -2.61100000e00, 1.01630000e01],
            [-1.54470000e01, -3.77300000e00, 1.37850000e01],
            [-1.74530000e01, -4.56800000e00, 1.49130000e01],
            [-1.96250000e01, -8.12100000e00, 3.09640000e01],
            [-1.87930000e01, -6.02700000e00, 3.00100000e01],
            [-2.21720000e01, -5.88500000e00, 2.73660000e01],
            [-2.30070000e01, -7.97000000e00, 2.83050000e01],
            [-2.28490000e01, -9.77500000e00, 2.97900000e01],
            [-2.02630000e01, -5.11300000e00, 2.59880000e01],
            [-1.95280000e01, -2.98800000e00, 2.50290000e01],
            [-1.87050000e01, -1.49400000e00, 2.89690000e01],
            [-1.94580000e01, -3.61600000e00, 2.99300000e01],
            [-1.97440000e01, 3.97000000e-01, 2.77710000e01],
            [-1.77240000e01, 2.63900000e00, 2.47450000e01],
            [-1.75010000e01, -1.63100000e00, 2.47540000e01],
            [-1.52500000e01, -9.22000000e-01, 2.40440000e01],
            [-1.39510000e01, -9.22000000e-01, 2.19700000e01],
            [-1.65960000e01, 2.02900000e00, 2.03170000e01],
            [-1.79050000e01, 2.01500000e00, 2.23820000e01],
            [-1.61630000e01, 4.55000000e-01, 1.84550000e01],
            [-1.49310000e01, 4.12000000e-01, 1.63560000e01],
            [-1.29290000e01, 4.04000000e-01, 1.51350000e01],
            [-1.12210000e01, 5.37000000e-01, 1.85370000e01],
            [-1.24700000e01, 5.86000000e-01, 2.06400000e01],
            [-2.13170000e01, 2.15500000e00, 2.71960000e01],
            [-2.22180000e01, 4.21900000e00, 2.81400000e01],
            [-1.83810000e01, 6.09600000e00, 2.77090000e01],
            [-1.74710000e01, 4.02000000e00, 2.67820000e01],
            [-1.92750000e01, 6.97700000e00, 2.98630000e01],
            [-2.02170000e01, 9.04200000e00, 3.07730000e01],
            [-2.35990000e01, 1.04140000e01, 2.96830000e01],
            [-2.36850000e01, 8.54400000e00, 2.82720000e01],
            [-2.27330000e01, 6.49600000e00, 2.73650000e01],
            [-2.73870000e01, -7.52400000e00, 3.08690000e01],
            [-2.81490000e01, -5.38000000e00, 2.99990000e01],
            [-3.12290000e01, -7.38100000e00, 2.77680000e01],
            [-3.05040000e01, -9.51600000e00, 2.86690000e01],
            [-2.91150000e01, -1.08250000e01, 3.00970000e01],
            [-3.23030000e01, -5.39400000e00, 2.82650000e01],
            [-3.30350000e01, -3.28100000e00, 2.72850000e01],
            [-2.89690000e01, -1.92100000e00, 2.71520000e01],
            [-2.82230000e01, -4.05000000e00, 2.80940000e01],
            [-3.05510000e01, 9.20000000e-02, 2.79700000e01],
            [-3.27070000e01, 2.12800000e00, 2.48910000e01],
            [-3.25620000e01, -2.14600000e00, 2.49330000e01],
            [-3.49290000e01, 1.45700000e00, 2.40740000e01],
            [-3.61540000e01, 1.42600000e00, 2.19550000e01],
            [-3.35140000e01, -1.61900000e00, 2.04750000e01],
            [-3.22780000e01, -1.57300000e00, 2.25800000e01],
            [-3.38640000e01, -1.25000000e-01, 1.85530000e01],
            [-3.50320000e01, -1.53000000e-01, 1.64170000e01],
            [-3.70060000e01, -1.64000000e-01, 1.51330000e01],
            [-3.88050000e01, -9.50000000e-02, 1.84890000e01],
            [-3.76210000e01, -7.80000000e-02, 2.06270000e01],
            [-3.32740000e01, 3.26100000e00, 2.72480000e01],
            [-3.26930000e01, 5.43100000e00, 2.82080000e01],
            [-2.85280000e01, 4.38400000e00, 2.80330000e01],
            [-2.91210000e01, 2.20000000e00, 2.71090000e01],
            [-3.17610000e01, 7.49000000e00, 2.76960000e01],
            [-3.11850000e01, 9.67600000e00, 2.85830000e01],
            [-2.98860000e01, 1.10880000e01, 3.00000000e01],
            [-2.79370000e01, 7.91800000e00, 3.07920000e01],
            [-2.85500000e01, 5.72100000e00, 2.99360000e01],
        ],
    ),
}


class TestAverageDiameter(unittest.TestCase):
    def test_case_1(self):
        molsys = pw.MolecularSystem.load_system(case_1, "case_1")
        mol = molsys.system_to_molecule()

        np.testing.assert_almost_equal(
            mol.calculate_average_diameter(), 12.38895620, decimal=3
        )

    def test_case_2(self):
        molsys = pw.MolecularSystem.load_system(case_2, "case_2")
        mol = molsys.system_to_molecule()

        np.testing.assert_almost_equal(
            mol.calculate_average_diameter(), 13.36606775, decimal=3
        )

    def test_case_3(self):
        molsys = pw.MolecularSystem.load_system(case_3, "case_3")
        mol = molsys.system_to_molecule()

        np.testing.assert_almost_equal(
            mol.calculate_average_diameter(), 18.10740925, decimal=3
        )

    def test_case_4(self):
        molsys = pw.MolecularSystem.load_system(case_4, "case_4")
        mol = molsys.system_to_molecule()

        np.testing.assert_almost_equal(
            mol.calculate_average_diameter(), 19.23547068, decimal=3
        )

    def test_case_5(self):
        molsys = pw.MolecularSystem.load_system(case_5, "case_5")
        mol = molsys.system_to_molecule()

        np.testing.assert_almost_equal(
            mol.calculate_average_diameter(), 24.03139233, decimal=3
        )


if __name__ == "__main__":
    unittest.main()
